//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "AutoRefresh.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include "..\..\MSXE371X_SOAP\gsoap_generated\MSXE371x.nsmap"
#include "..\UTIL\AddiUtility.h"
#include "..\UTIL\AddiSocket.h"


#define MSXE3711_IP_ADDRESS                 "172.16.3.240"
#define MSXE3711_TRANSDUCER_SELECTION       1
#define MSXE3711_AUTO_REFRESH_AVERAGE_VALUE 1
#define MSXE3711_AUTO_REFRESH_CHANNEL_MASK  0xFF
#define MSXE3711_AUTO_REFRESH_OPTTION       2

#if MSXE3711_AUTO_REFRESH_AVERAGE_VALUE > 1
   #define MSXE3711_AUTO_REFRESH_AVERAGE_MODE 1
#else
   #define MSXE3711_AUTO_REFRESH_AVERAGE_MODE 0
#endif


TMainForm *MainForm;
char          c_SOAPIPAddress [100];
HANDLE        h_ThreadHandle = 0;
DWORD        dw_ThreadId     = 0;
struct soap *ps_SoapEnv      = NULL;
SOCKET        s_ClientSocket;

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}

DWORD WINAPI dw_ThreadProc (LPVOID lpParameter)
{
 int     i_Return          = 0;
 DWORD  dw_MaxChannels     = 0;
 DWORD  dw_DataIndex       = 0;
 DWORD  dw_RequestValue    = 0;
 DWORD  dw_RequestIndex    = 0;
 DWORD  dw_AutoRefreshData [15];
 float *pf_AutoRefreshData = (float *) &dw_AutoRefreshData;
 DWORD  dw_SocketDataSize  =  4 + // Auto refresh counter
                              ((MSXE3711_AUTO_REFRESH_OPTTION >> 0) & 1) * 8 + // Time stamp
                              ((MSXE3711_AUTO_REFRESH_OPTTION >> 3) & 1) * 4 + // External temperature
                              ((MSXE3711_AUTO_REFRESH_OPTTION >> 4) & 1) * 4;  // Incremental counter

 /* Get the number of channels via the channel mask */

 for (int i = 0; i < 8; i ++)
    {
    dw_SocketDataSize = dw_SocketDataSize + (((MSXE3711_AUTO_REFRESH_CHANNEL_MASK >> i) & 1) * 4);
    dw_MaxChannels    = dw_MaxChannels + ((MSXE3711_AUTO_REFRESH_CHANNEL_MASK >> i) & 1);
    }

 for (;;)
    {
    dw_DataIndex    = 0;
    dw_RequestValue = dw_SocketDataSize;
    dw_RequestIndex = 0;

    /* Read the selected number of datas */

    do
       {
       i_Return = recv (s_ClientSocket, (char *) &dw_AutoRefreshData [dw_RequestIndex / 4], dw_RequestValue, 0);

       if (i_Return != SOCKET_ERROR)
          {
	  dw_RequestIndex = dw_RequestIndex + i_Return;
	  dw_RequestValue = dw_RequestValue - i_Return;
          }
       }
    while ((dw_RequestIndex < dw_SocketDataSize) && (i_Return != SOCKET_ERROR));

    /* Test if no error occur */

    if (i_Return > 0)
       {
       String s_Data = "";

       #if (MSXE3711_AUTO_REFRESH_OPTTION & 1) == 1
          /* Convert the time stamp */

          s_Data       = ConvertTimeStamp (dw_AutoRefreshData[0], dw_AutoRefreshData[1]);
          dw_DataIndex = 2;
       #endif

       /* Get the auto refresh counter value */

       s_Data       = s_Data + " Auto refresh counter = " + dw_AutoRefreshData[dw_DataIndex];
       dw_DataIndex = dw_DataIndex + 1;

       #if (MSXE3711_AUTO_REFRESH_OPTTION & 8) == 8
          /* Get the external temperature value */

          s_Data       = s_Data + " External temperature = " + dw_AutoRefreshData[dw_DataIndex];
          dw_DataIndex = dw_DataIndex + 1;
       #endif

       #if (MSXE3711_AUTO_REFRESH_OPTTION & 16) == 16
          /* Get the incremental counter value */

          s_Data       = s_Data + " Incremental counter = " + dw_AutoRefreshData[dw_DataIndex];
          dw_DataIndex = dw_DataIndex + 1;
       #endif

       /* Get the transducer channels value */

       s_Data = s_Data + "\nChannel(s):";
       
       #if (MSXE3711_AUTO_REFRESH_OPTTION & 2) == 2
          for (DWORD dw_Cpt = 0; dw_Cpt < dw_MaxChannels; dw_Cpt ++)
             {
             s_Data = s_Data + " " + FormatFloat("#,####0.0000", pf_AutoRefreshData[dw_DataIndex + dw_Cpt]) + "mm";
             }
       #else
          for (DWORD dw_Cpt = 0; dw_Cpt < dw_MaxChannels; dw_Cpt ++)
             {
             s_Data = s_Data + " " + IntToHex ((int) dw_AutoRefreshData[dw_DataIndex + dw_Cpt], 6);
             }
       #endif

       MainForm->SocketData->Caption = s_Data;
       }
    else
       {
       MainForm->ErrorStatus->Caption = "Socket error " + i_Return;
       break;
       }
    }

 return (0);
}


//---------------------------------------------------------------------------
void __fastcall TMainForm::StartClick(TObject *Sender)
{
 int                       i_Error = 0;
 struct MSXE371x__Response s_Response;

 sprintf(c_SOAPIPAddress,"%s:5555", MSXE3711_IP_ADDRESS);

 /* SOAP connection initialisation */

 if (i_SOAP_Init(&ps_SoapEnv) == 0)
    {
    /* Open the data server socket */

    if (i_Socket_ClientOpen(MSXE3711_IP_ADDRESS,8989,&s_ClientSocket) == 0)
       {
       /* Create the read data server thread */

       h_ThreadHandle = CreateThread (NULL,
                                      0,
                                      dw_ThreadProc,
                                      NULL,
                                      0,
                                      &dw_ThreadId);

       /* Auto refresh initialisation and start*/

       i_Error = soap_call_MSXE371x__TransducerInitAndStartAutoRefresh (ps_SoapEnv,
                                                                        c_SOAPIPAddress ,
                                                                        SOAP_ACTION,
                                                                        MSXE3711_TRANSDUCER_SELECTION,
                                                                        MSXE3711_AUTO_REFRESH_CHANNEL_MASK,
                                                                        MSXE3711_AUTO_REFRESH_AVERAGE_MODE,
                                                                        MSXE3711_AUTO_REFRESH_AVERAGE_VALUE,
                                                                        0,
                                                                        0,
                                                                        0,
                                                                        0,
                                                                        0,
                                                                        MSXE3711_AUTO_REFRESH_OPTTION,
                                                                        0,
                                                                        0,
                                                                        0,
                                                                        0,
                                                                        &s_Response);

       if (i_Error)
          {
          ErrorStatus->Caption = "SOAP Error : " & (String) *soap_faultstring(ps_SoapEnv);
          }
       else if (s_Response.iReturnValue != 0)
          {
          ErrorStatus->Caption = "soap_call_MSXE371x__TransducerInitAndStartAutoRefresh response error: " + s_Response.iReturnValue;
          }
       else
          {
          Start->Enabled = false;
          Stop->Enabled  = true;
          }
       }
    else
       {
       ErrorStatus->Caption = "Data server socket connection error\nCheck the module IP address";
       }
    }
 else
    {
    ErrorStatus->Caption = "SOAP initialisation error";
    }
	
	/* 
	 * gSOAP doesn't release automatically the memory that 
	 * it allocates to deserialize data, that's why both 
	 * following functions have to be used to release the 
	 * allocated memory.
	 */
	soap_destroy(ps_SoapEnv);
	soap_end(ps_SoapEnv);	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StopClick(TObject *Sender)
{
 int                       i_Error = 0;
 struct MSXE371x__Response s_Response;

 if (Stop->Enabled == true)
    {
    /* Stop the auto refresh acquisition */

    i_Error = soap_call_MSXE371x__TransducerStopAndReleaseAutoRefresh(ps_SoapEnv, c_SOAPIPAddress, SOAP_ACTION, NULL, &s_Response);

    if (i_Error)
       {
       ErrorStatus->Caption = "SOAP Error : " & (String) *soap_faultstring(ps_SoapEnv);
       }
    else if (s_Response.iReturnValue != 0)
       {
       ErrorStatus->Caption = "soap_call_MSXE371x__TransducerStopAndReleaseAutoRefresh response error: " + s_Response.iReturnValue;
       }
    else
       {
       /* Close the socket connection */
       i_Socket_ClientClose (s_ClientSocket);

       /* Close the SOAP connection */
       i_SOAP_Close (ps_SoapEnv);

       Start->Enabled = true;
       Stop->Enabled  = false;
       }
    }
 }
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
 StopClick (Sender);
}
//---------------------------------------------------------------------------

