
#include <sys\types.h>
#include <time.h>
#include <stdlib.h>

#include "AddiUtility.h"
#include "..\..\MSXE371X_SOAP\gsoap_generated\stdsoap2.h"

//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------

/** Display a timeval struct in human string
 *
 * Convert and save date and time element
 * of a timeval struct in comprehensible outputs:
 * day/month/years hour:min.:sec.:msec.:usec.
 */
char *DisplayTimeStamp (DWORD TimeStampHigh, DWORD TimeStampLow)
{
	struct tm *tm_ptr;
        time_t useconds, mseconds;
static  char c_Write [300];

        tm_ptr = localtime ((const time_t *) &TimeStampHigh);
        useconds = TimeStampLow;
        mseconds = useconds/1000;
        useconds -= (mseconds * 1000);
        printf ("%02d/%02d/%04d-%02d:%02d:%02d:%03ld:%03ld ", tm_ptr->tm_mday, (tm_ptr->tm_mon+1), (tm_ptr->tm_year + 1900), tm_ptr->tm_hour, tm_ptr->tm_min, tm_ptr->tm_sec, mseconds, useconds);
        sprintf(c_Write,"%02d/%02d/%04d-%02d:%02d:%02d:%03ld:%03ld ", tm_ptr->tm_mday, (tm_ptr->tm_mon+1), (tm_ptr->tm_year + 1900), tm_ptr->tm_hour, tm_ptr->tm_min, tm_ptr->tm_sec, mseconds, useconds);

       return c_Write;
}


/** Convert a timeval struct in human string
 *
 * Convert and save date and time element
 * of a timeval struct in comprehensible outputs:
 * day/month/years hour:min.:sec.:msec.:usec.
 */
char *ConvertTimeStamp (DWORD TimeStampHigh, DWORD TimeStampLow)
{
	struct tm *tm_ptr;
        time_t useconds, mseconds;
static  char c_Write [300];

        tm_ptr = localtime ((const time_t *)&TimeStampHigh);
        useconds = TimeStampLow;
        mseconds = useconds/1000;
        useconds -= (mseconds * 1000);
        sprintf(c_Write,"%02d/%02d/%04d-%02d:%02d:%02d:%03ld:%03ld ", tm_ptr->tm_mday, (tm_ptr->tm_mon+1), (tm_ptr->tm_year + 1900), tm_ptr->tm_hour, tm_ptr->tm_min, tm_ptr->tm_sec, mseconds, useconds);

       return c_Write;
}



//-------------------------------------------------------------------------------------------------------
//                                       SOAP function
//-------------------------------------------------------------------------------------------------------

int i_SOAP_Init(struct soap **ps_SoapEnv)
{
	/* Initialise the SOAP connection */
	*ps_SoapEnv = soap_new();

	if (*ps_SoapEnv != NULL)
	{
		soap_init2(*ps_SoapEnv, SOAP_IO_KEEPALIVE, SOAP_IO_KEEPALIVE);
		(*ps_SoapEnv) -> send_timeout = 1;
		(*ps_SoapEnv) -> recv_timeout = 1;
		(*ps_SoapEnv) -> accept_timeout = 1;
		return 0;
	}
	printf ("Fail to initialize the SOAP connection\n");
	return -1;
}

//-------------------------------------------------------------------------------------------------------

int i_SOAP_Close(struct soap *ps_SoapEnv)
{
	soap_destroy(ps_SoapEnv);
	soap_end(ps_SoapEnv);
	soap_free(ps_SoapEnv);
	return 0;
}

