using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace IncCounterReadWriteClear
{
    public partial class IncCounterReadWriteClear : Form
    {
        private ArrayList CounterOptions0 = new ArrayList();
        private ArrayList CounterOptions1 = new ArrayList();
        private MXCommon_WebReference.MXCommon MX_Common;
        private MSXE371x_WebReference.MSXE371x MSXE371x;
        private MSXE371x_WebReference.DefaultResponse Response;
        private int   RetValue        = 0;
        private int   syserno         = 0;
        private ulong ulCounterValue  = 0;
        private ulong ulTimeStampHigh = 0;
        private ulong ulTimeStampLow  = 0;

        public IncCounterReadWriteClear()
        {
            InitializeComponent();
        }

        public static DateTime ConvertFromTime_T(long time_t)
        {
            DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
            long tickTotal = dt70.Ticks + (time_t * 10000000L);
            DateTime netTimeT = new DateTime(tickTotal);
            return netTimeT;
        }

        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string strItem, long lValue)
            {

                this.myItem = strItem;
                this.myValue = lValue;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }

        private void IncCounterReadWriteClear_Load(object sender, EventArgs e)
        {
            MX_Common = new MXCommon_WebReference.MXCommon();
            MSXE371x  = new MSXE371x_WebReference.MSXE371x();
            MX_Common.Timeout = 2000;
            MSXE371x.Timeout  = 2000;

            // Counter mode list box initialisation

            ArrayList CounterModes = new ArrayList();
            CounterModes.Add(new ListData("Simple mode", 1));
            CounterModes.Add(new ListData("Double mode", 2));
            CounterModes.Add(new ListData("Quadruple mode", 4));
            CounterModes.Add(new ListData("Direct", 0));

            LB_IC_Mode.DisplayMember = "Item";
            LB_IC_Mode.ValueMember   = "Value";
            LB_IC_Mode.DataSource    = CounterModes;

            // Counter option list box initialisation

            CounterOptions0.Add(new ListData("Hysteresus on", 1));
            CounterOptions0.Add(new ListData("Hysteresus off", 0));
            CounterOptions1.Add(new ListData("Increment", 0));
            CounterOptions1.Add(new ListData("Decrement", 1));

            LB_IC_Option.DataSource    = CounterOptions0;
            LB_IC_Option.DisplayMember = "Item";
            LB_IC_Option.ValueMember   = "Value";

            // Counter compare mode list box initialisation

            ArrayList CompareModes = new ArrayList();
            CompareModes.Add(new ListData("Equals compare value", 0));
            CompareModes.Add(new ListData("Equals a multiple of the compare value", 1));

            LB_IC_CompareMode.DataSource    = CompareModes;
            LB_IC_CompareMode.DisplayMember = "Item";
            LB_IC_CompareMode.ValueMember   = "Value";

            // Counter compare options list box initialisation

            ArrayList CompareOptions = new ArrayList();
            CompareOptions.Add(new ListData("No synchro trigger used", 0));
            CompareOptions.Add(new ListData("Generates a synchro trigger", 1));

            LB_IC_SynchroTrigger.DataSource = CompareOptions;
            LB_IC_SynchroTrigger.DisplayMember = "Item";
            LB_IC_SynchroTrigger.ValueMember = "Value";
        }

        private void LB_IC_Mode_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Convert.ToUInt32(LB_IC_Mode.SelectedValue) == 0)
            {
                LB_IC_Option.DataSource = CounterOptions1;
            }
            else
            {
                LB_IC_Option.DataSource = CounterOptions0;
            }
        }

        private void B_StartSample_Click(object sender, EventArgs e)
        {
            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                MSXE371x.Url = MX_Common.Url;

                                try
                                {
                                    // Counter initialisation

                                    RetValue = MSXE371x.IncCounterInit(Convert.ToUInt32 (LB_IC_Mode.SelectedValue),
                                                                       Convert.ToUInt32 (LB_IC_Option.SelectedValue),
                                                                       0,
                                                                       0,
                                                                       0,
                                                                       0,
                                                                       out syserno);
                                    if (RetValue != 0)
                                    {
                                        MessageBox.Show("IncCounterInit Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    }
                                    else
                                    {
                                        T_ReadValue.Enabled = true;
                                        B_StartSample.Enabled = false;
                                        B_StopSample.Enabled = true;
                                        GB_Counter.Enabled = false;
                                        B_IC_ClearCounter.Enabled = true;
                                        B_IC_WriteCounter.Enabled = true;
                                        b_IC_InitCompare.Enabled = true;
                                        TB_IC_WriteCounter.Enabled = true;
                                    }
                                }

                                catch (Exception ex)
                                {
                                    MessageBox.Show("IncCounterInit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }

                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_StopSample_Click(object sender, EventArgs e)
        {
            if (B_IC_ReleaseCompare.Enabled == true)
            {
                B_IC_ReleaseCompare_Click(sender, e);
            }

            if (B_StopSample.Enabled == true)
            {
                try
                {
                    // Counter compare initialisation

                    RetValue = MSXE371x.IncCounterRelease(out syserno);
                    if (RetValue != 0)
                    {
                        MessageBox.Show("IncCounterRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                    else
                    {
                        T_ReadValue.Enabled = false;
                        B_StartSample.Enabled = true;
                        B_StopSample.Enabled = false;
                        GB_Counter.Enabled = true;
                        B_IC_ClearCounter.Enabled = false;
                        B_IC_WriteCounter.Enabled = false;
                        b_IC_InitCompare.Enabled = false;
                        TB_IC_WriteCounter.Enabled = false;
                    }
                }

                catch (Exception ex)
                {
                    MessageBox.Show("IncCounterRelease Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void b_IC_InitCompare_Click(object sender, EventArgs e)
        {
            if ((Convert.ToInt64(TB_IC_CompareValue.Text) >= 1) && (Convert.ToInt64(TB_IC_CompareValue.Text) <= 0xffffffff))
            {
                try
                {
                    // Counter compare initialisation

                    RetValue = MSXE371x.IncCounterInitAndEnableCompareLogic(Convert.ToUInt64(TB_IC_CompareValue.Text), 
                                                                            Convert.ToUInt32 (LB_IC_CompareMode.SelectedValue), 
                                                                            Convert.ToUInt32 (LB_IC_SynchroTrigger.SelectedValue), 
                                                                            0, 
                                                                            0, 
                                                                            out syserno);
                    if (RetValue != 0)
                    {
                        MessageBox.Show("IncCounterInitAndEnableCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                    else
                    {
                        b_IC_InitCompare.Enabled = false;
                        B_IC_ReleaseCompare.Enabled = true;
                        GB_CounterCompare.Enabled = false;
                    }
                }

                catch (Exception ex)
                {
                    MessageBox.Show("IncCounterInitAndEnableCompareLogic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            else
            {
                MessageBox.Show("The compare value to write must be comprised between 1 and 4294967295.", "Parameter error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_IC_ReleaseCompare_Click(object sender, EventArgs e)
        {
            try
            {
                // Release the counter compare logic

                RetValue = MSXE371x.IncCounterDisableAndReleaseCompareLogic(out syserno);
                if (RetValue != 0)
                {
                    MessageBox.Show("IncCounterDisableAndReleaseCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("IncCounterDisableAndReleaseCompareLogic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            b_IC_InitCompare.Enabled = true;
            B_IC_ReleaseCompare.Enabled = false;
            GB_CounterCompare.Enabled = true;
        }

        private void B_IC_ClearCounter_Click(object sender, EventArgs e)
        {
            try
            {
                // Clear the counter value

                RetValue = MSXE371x.IncCounterClear(out syserno);
                if (RetValue != 0)
                {
                    MessageBox.Show("IncCounterClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("IncCounterClear Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }

        private void B_IC_WriteCounter_Click(object sender, EventArgs e)
        {
            try
            {
                // Write the counter value

                RetValue = MSXE371x.IncCounterWrite32BitValue(Convert.ToUInt64 (TB_IC_WriteCounter.Text), out syserno);
                if (RetValue != 0)
                {
                    MessageBox.Show("IncCounterWrite32BitValue Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("IncCounterWrite32BitValue Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }

        private void T_ReadValue_Tick(object sender, EventArgs e)
        {
            UInt64 ulTimeStampLowmus = 0;
            UInt64 ulTimeStampLowms = 0;
            String sTimeStamp;

            try
            {
                // Read the counter value

                Response = MSXE371x.IncCounterRead32BitValue(out ulCounterValue, out ulTimeStampLow, out ulTimeStampHigh);
                if (Response.iReturnValue != 0)
                {
                    MessageBox.Show("IncCounterRead32BitValue Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    ulTimeStampLowms = (ulong)(ulTimeStampLow / 1000);
                    ulTimeStampLowmus = (ulong)(ulTimeStampLow % 1000);
                    sTimeStamp = "Time stamp: " + ConvertFromTime_T((long)ulTimeStampHigh).ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3");

                    L_CounterInfo.Text = "Counter = " + ulCounterValue.ToString() + " (dec). " + sTimeStamp;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("IncCounterRead32BitValue Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void IncCounterReadWriteClear_FormClosing(object sender, FormClosingEventArgs e)
        {
            B_StopSample_Click(sender, null);
        }
    }
}