using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Net;
using System.Net.Sockets;
using Transducer;

namespace TransducerDiagnostic
{
    public partial class TransducerDiagnostic : Form
    {
        // Global Variable
        private MXCommon_WebReference.MXCommon MX_Common;
        private MSXE371x_WebReference.MSXE371x MSXE371x;
        private MXCommon_WebReference.DefaultResponse MXResponse;
        private MSXE371x_WebReference.DefaultResponse Response;
        private int RetValue = 0;
        private int syserno = 0;
        private TcpClient Socket;
        private NetworkStream Stream;
        private byte[] bBuffer      = new byte[100];
        private byte[] bEventFormat = new byte[1];
        private byte[] bEventSize = new byte[255];
        private TranducerInfo[] TranducerInformations;
        private byte S_IODRIVER     = 2;


        private UInt64 ulGetNbrOfTransducerChannel(String sModuleType)
        {
            if (sModuleType.IndexOf("-", 0) == -1)
                return 0;
            sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1);

            if (sModuleType.IndexOf("-", 0) == -1)
                return 0;
            sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1);

            if (sModuleType.IndexOf("-", 0) == -1)
                return 0;
            sModuleType = sModuleType.Remove(sModuleType.IndexOf("-", 0));

            return (Convert.ToUInt64(sModuleType));
        }

        private string s_GetSysErrnoString(int isyserrno)
        {
            byte[] pbErrno;
            MXCommon_WebReference.DefaultResponse dResponse;
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();

            dResponse = MX_Common.Strerror(isyserrno, out pbErrno);
            if (dResponse.iReturnValue == 0)
                return (enc.GetString(pbErrno));
            else
                return ("unknown error");
        }


        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string strItem, long lValue)
            {

                this.myItem = strItem;
                this.myValue = lValue;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }

        public TransducerDiagnostic()
        {
            InitializeComponent();
        }

        private void TransducerDiagnostic_Load(object sender, EventArgs e)
        {
            MX_Common = new MXCommon_WebReference.MXCommon();
            MSXE371x = new MSXE371x_WebReference.MSXE371x();
            MX_Common.Timeout = 5000;
            MSXE371x.Timeout = 10000;
        }



        private void B_Connect_Click(object sender, EventArgs e)
        {
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
            byte[] pcName = new byte[255];
            ulong ulNbrOfTransducers;
            ulong ulNbrOfChannels;
            ulong ulSelectionIndex;
            ulong ulCalibrationStatus;
            ulong ulCalibratedChannels;
            ulong ulType;
            ulong ulFrequency;
            ulong ulImpedance;
            double dVeff;
            double dSensibility;
            double dRange;

            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                GB_EventMonitoring.Enabled = false;
                                GB_SecondaryTest.Enabled = false;
                                GB_PrimaryTest.Enabled = false;
                                GB_Transducers.Enabled = false;

                                MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                MSXE371x.Url = MX_Common.Url;

                                try
                                {
                                    // Get the number of transducers type
                                    Response = MSXE371x.TransducerGetNbrOfType(out ulNbrOfTransducers);
                                    if (Response.iReturnValue != 0)
                                    {
                                        MessageBox.Show("TransducerGetNbrOfType Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }
                                    else if (ulNbrOfTransducers == 0)
                                    {
                                        MessageBox.Show("TransducerGetNbrOfType Error : No transducer in database", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }
                                }

                                catch (Exception ex)
                                {
                                    MessageBox.Show("TransducerGetNbrOfType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }
                                try
                                {
                                    if (ulNbrOfTransducers != 0)
                                    {
                                        TranducerInformations = new TranducerInfo[ulNbrOfTransducers];
                                        ArrayList Transducers = new ArrayList();
                                        L_NbrOfTransducers.Text = ulNbrOfTransducers.ToString();

                                        for (ulong ulCpt = 0; ulCpt < ulNbrOfTransducers; ulCpt++)
                                        {
                                            // Get the transducer informations
                                            MSXE371x.TransducerGetTypeInformation(ulCpt,
                                                                                  out ulSelectionIndex,
                                                                                  out pcName,
                                                                                  out ulCalibrationStatus,
                                                                                  out ulCalibratedChannels,
                                                                                  out ulType,
                                                                                  out ulFrequency,
                                                                                  out ulImpedance,
                                                                                  out dVeff,
                                                                                  out dSensibility,
                                                                                  out dRange);

                                            // Save the transducer informations
                                            TranducerInformations[ulCpt] = new TranducerInfo(ulSelectionIndex,
                                                                                             enc.GetString(pcName),
                                                                                             ulCalibrationStatus,
                                                                                             ulCalibratedChannels,
                                                                                             ulType,
                                                                                             ulFrequency,
                                                                                             ulImpedance,
                                                                                             dVeff,
                                                                                             dSensibility,
                                                                                             dRange);

                                            Transducers.Add(new ListData(enc.GetString(pcName), (long)ulSelectionIndex));
                                        }

                                        LB_TransducerList.DataSource = Transducers;
                                        LB_TransducerList.DisplayMember = "Item";
                                        LB_TransducerList.ValueMember = "Value";
                                        // Get the module type
                                    }
                                    MXResponse = MX_Common.GetModuleType(out pcName);
                                    if (MXResponse.iReturnValue != 0)
                                    {
                                        MessageBox.Show("GetModuleType Error : " + MXResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }
                                    if (enc.GetString(pcName).Contains("M MX371X{"))
                                    {
                                        B_PrimaryInitialisation.Enabled = false;
                                        B_SecondaryConnectionTest.Enabled = false;
                                        b_SecondaryShortCircuitTest.Enabled = false;
                                        LB_Channel.Enabled = false;
                                    }
                                    else
                                    {
                                        B_PrimaryInitialisation.Enabled = true;
                                        B_SecondaryConnectionTest.Enabled = true;
                                        b_SecondaryShortCircuitTest.Enabled = true;
                                        LB_Channel.Enabled = true;
                                    }
                                }

                                catch (Exception ex)
                                {
                                    MessageBox.Show("GetModuleType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }

                                ulNbrOfChannels = ulGetNbrOfTransducerChannel(enc.GetString(pcName));
                                ArrayList Channels = new ArrayList();
                                for (long i = 0; i < (long)ulNbrOfChannels; i++)
                                {
                                    Channels.Add(new ListData(i.ToString(), i));
                                }

                                LB_Channel.DisplayMember = "Item";
                                LB_Channel.ValueMember = "Value";
                                LB_Channel.DataSource = Channels;

                                GB_EventMonitoring.Enabled = true;
                                GB_SecondaryTest.Enabled = true;
                                GB_PrimaryTest.Enabled = true;
                                GB_Transducers.Enabled = true;

                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_PrimaryInitialisation_Click(object sender, EventArgs e)
        {
            int cpt = 0xFFFF;
            for (int i = 0; i < TranducerInformations.Length; i++)
            {
                if (TranducerInformations[i].SelectionIndex == Convert.ToUInt64(LB_TransducerList.SelectedValue))
                {
                    cpt = i;
                    break;
                }
            }
            try
            {
                if (cpt != 0xFFFF)
                    RetValue = MSXE371x.TransducerInit(Convert.ToUInt64(LB_TransducerList.SelectedValue), TranducerInformations[cpt].Frequency, out syserno);
                RetValue = MSXE371x.TransducerInitPrimaryConnectionTest(out syserno);
                if (RetValue == 0)
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerInitPrimaryConnectionTest OK " + Environment.NewLine;
                    B_PrimaryConnectionTest.Enabled = true;
                }
                else
                {
                    TB_DiagnosticStatus.Text = "TransducerInitPrimaryConnectionTest Error : " + RetValue.ToString();

                    if (RetValue == -1)
                        TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + " " + s_GetSysErrnoString(syserno);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("TransducerInitPrimaryConnectionTest Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length;
            TB_DiagnosticStatus.ScrollToCaret();
        }

        private void B_PrimaryConnectionTest_Click(object sender, EventArgs e)
        {
            string[] sStatus = new String[] {"Any connection open", "All connections OK"};
            ulong ulStatus;

            try
            {
                Response = MSXE371x.TransducerTestPrimaryConnection(out ulStatus);

                if (Response.iReturnValue == 0)
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryConnection OK Status : " + sStatus[ulStatus] + " (" + ulStatus.ToString() + ")" + Environment.NewLine;
                }
                else
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryConnection Error : " + Response.iReturnValue.ToString() + Environment.NewLine;

                    if (Response.iReturnValue == -1)
                        TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("TransducerTestPrimaryConnection Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length;
            TB_DiagnosticStatus.ScrollToCaret();
        }

        private void b_PrimaryShortCircuitTest_Click(object sender, EventArgs e)
        {
            ulong ulStatus;
            string[] sStatus = new String[] { "Short circuit detected", "No short circuit" };

            try
            {
                Response = MSXE371x.TransducerTestPrimaryShortCircuit(out ulStatus);
                if (Response.iReturnValue == 0)
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryShortCircuit OK Status : " + sStatus[ulStatus] + " (" + ulStatus.ToString() + ")" + Environment.NewLine;
                }
                else
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryShortCircuit Error : " + Response.iReturnValue.ToString() + Environment.NewLine;
                    if (Response.iReturnValue == -1)
                        TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("TransducerTestPrimaryShortCircuit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length;
            TB_DiagnosticStatus.ScrollToCaret();
        }

        private void B_RearmPrimary_Click(object sender, EventArgs e)
        {
            ulong ulStatus;
            string[] sStatus = new String[] { "Short circuit persist", "Rearm OK" };

            try
            {
                Response = MSXE371x.TransducerRearmPrimary(out ulStatus);
                if (Response.iReturnValue == 0)
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerRearmPrimary OK Status : " + sStatus[ulStatus] + " (" + ulStatus.ToString() + ")" + Environment.NewLine;
                }
                else
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerRearmPrimary Error : " + Response.iReturnValue.ToString() + Environment.NewLine;
                    if (Response.iReturnValue == -1)
                        TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("TransducerRearmPrimary Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length;
            TB_DiagnosticStatus.ScrollToCaret();
        }

        private void B_SecondaryConnectionTest_Click(object sender, EventArgs e)
        {
            ulong ulStatus;
            string[] sStatus = new String[] { "Connection open", "Connection OK" };

            try
            {
                Response = MSXE371x.TransducerTestSecondaryConnection(Convert.ToUInt32(LB_Channel.SelectedValue), out ulStatus);
                if (Response.iReturnValue == 0)
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryConnection OK Channel: " + sStatus[ulStatus] + " (" + ulStatus.ToString() + ")" + Environment.NewLine;
                }
                else
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryConnection Error : " + Response.iReturnValue.ToString() + Environment.NewLine;
                    if (Response.iReturnValue == -1)
                        TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("TransducerTestSecondaryConnection Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length;
            TB_DiagnosticStatus.ScrollToCaret();
        }

        private void b_SecondaryShortCircuitTest_Click(object sender, EventArgs e)
        {
            ulong ulStatus;
            string[] sStatus = new String[] { "Short circuit detected", "No short circuit" };

            try
            {
                Response = MSXE371x.TransducerTestSecondaryShortCircuit(Convert.ToUInt32(LB_Channel.SelectedValue), out ulStatus);
                if (Response.iReturnValue == 0)
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryShortCircuit OK Channel: " + sStatus[ulStatus] + " (" + ulStatus.ToString() + ")" + Environment.NewLine;
                }
                else
                {
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryShortCircuit Error : " + Response.iReturnValue.ToString() + Environment.NewLine;
                    if (Response.iReturnValue == -1)
                        TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("TransducerTestSecondaryShortCircuit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length;
            TB_DiagnosticStatus.ScrollToCaret();
        }

        private void B_StartEventMonitoring_Click(object sender, EventArgs e)
        {
            try
            {
                Socket = new TcpClient();

                // Open the socket connection to receive the event
                Socket.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 6363);

                Socket.ReceiveBufferSize = 1048576;

                TB_EventMonitor.Text = "Socket connected" + Environment.NewLine;

                Stream = Socket.GetStream();

                T_Event.Enabled = true;
                B_StopEventMonitoring.Enabled = true;
                B_StartEventMonitoring.Enabled = false;


            }
            catch (Exception ex)
            {
                MessageBox.Show("Socket connection Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }

        private void T_Event_Tick(object sender, EventArgs e)
        {
            int iReceive = 0;

            try
            {
                // Test if data available
                if (Stream.DataAvailable == true)
                    // Read the event format
                    iReceive = Stream.Read(bEventFormat, 0, 1);

                if (bEventFormat[0] == 0)
                {
                    // Test if data available
                    if (Stream.DataAvailable == true)
                        // Read the event size
                        iReceive = Stream.Read(bEventSize, 0, 1);

                    // Test if data available
                    if (Stream.DataAvailable == true)
                        // Read the event
                        iReceive = Stream.Read(bBuffer, 0, bEventSize[0]);
                }
                else
                {
                    TB_EventMonitor.Text = TB_EventMonitor.Text + "Event format not recognized" + Environment.NewLine;
                    TB_EventMonitor.SelectionStart = TB_EventMonitor.Text.Length;
                    TB_EventMonitor.ScrollToCaret();
                    T_Event.Enabled = false;
                    B_StopEventMonitoring_Click(sender, e);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("Socket Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                T_Event.Enabled = false;
                B_StopEventMonitoring_Click(sender, e);
            }

            if (iReceive == bEventSize[0])
            {
                // Test the event type
                if (bBuffer[0] == S_IODRIVER)
                {
                    TB_EventMonitor.Text = TB_EventMonitor.Text + "ioDriver event received, Status :" + bBuffer[1].ToString() + Environment.NewLine;
                    TB_EventMonitor.SelectionStart = TB_EventMonitor.Text.Length;
                    TB_EventMonitor.ScrollToCaret();
                }
            }
        }

        private void B_StopEventMonitoring_Click(object sender, EventArgs e)
        {
            T_Event.Enabled = false;
            if (B_StopEventMonitoring.Enabled == true)
            {

                try
                {
                    // Close the socket connection
                    Socket.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Socket Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }

                B_StartEventMonitoring.Enabled = true;
                B_StopEventMonitoring.Enabled = false;
            }
        }

        private void TransducerDiagnostic_FormClosing(object sender, FormClosingEventArgs e)
        {
            B_StopEventMonitoring_Click(sender, null);
        }
    }
}