using System;
using System.Collections.Generic;
using System.Text;

namespace Transducer
{
    public class TranducerInfo
    {
        private ulong ulSelectionIndex;
        private String sName;
        private ulong ulCalibrationStatus;
        private ulong ulCalibratedChannels;
        private ulong ulType;
        private ulong ulFrequency;
        private ulong ulImpedance;
        private double dVeff;
        private double dSensibility;
        private double dRange;

        public TranducerInfo(ulong SelectionIndex,
                             String Name,
                             ulong CalibrationStatus,
                             ulong CalibratedChannels,
                             ulong Type,
                             ulong Frequency,
                             ulong Impedance,
                             double Veff,
                             double Sensibility,
                             double Range)
        {
            ulSelectionIndex = SelectionIndex;
            sName = Name.Remove(Name.IndexOf((char)0));
            ulCalibrationStatus = CalibrationStatus;
            ulCalibratedChannels = CalibratedChannels;
            ulType = Type;
            ulFrequency = Frequency;
            ulImpedance = Impedance;
            dVeff = Veff;
            dSensibility = Sensibility;
            dRange = Range;
        }

        public ulong SelectionIndex { get { return (ulSelectionIndex); } set { ulSelectionIndex = value; } }
        public ulong CalibrationStatus { get { return (ulCalibrationStatus); } set { ulCalibrationStatus = value; } }
        public ulong CalibratedChannels { get { return (ulCalibratedChannels); } set { ulCalibratedChannels = value; } }
        public ulong Type { get { return (ulType); } set { ulType = value; } }
        public ulong Frequency { get { return (ulFrequency); } set { ulFrequency = value; } }
        public ulong Impedance { get { return (ulImpedance); } set { ulImpedance = value; } }
        public double Veff { get { return (dVeff); } set { dVeff = value; } }
        public double Sensibility { get { return (dSensibility); } set { dSensibility = value; } }
        public double Range { get { return (dRange); } set { dRange = value; } }
        public String Name { get { return (sName); } set { sName = value; } }

        public override String ToString()
        {
            String sRet;

            sRet = "Transducer Selection Index : " + ulSelectionIndex.ToString();
            sRet = sRet + Environment.NewLine + "Name                                   : " + sName;
            sRet = sRet + Environment.NewLine + "Calibration status                  : " + ulCalibrationStatus.ToString();
            sRet = sRet + Environment.NewLine + "Type Value                          : " + ulType.ToString();
            sRet = sRet + Environment.NewLine + "Frequency                           : " + ulFrequency.ToString() + " Hz";
            sRet = sRet + Environment.NewLine + "Impedance                          : " + ulImpedance.ToString() + " Ohm";
            sRet = sRet + Environment.NewLine + "Nominal Voltage                  : " + dVeff.ToString() + " V";
            sRet = sRet + Environment.NewLine + "Sensibility                            : " + dSensibility.ToString() + " mV/V/mm";
            sRet = sRet + Environment.NewLine + "Range                                 : +/-" + dRange.ToString() + " mm";

            return (sRet);
        }
    }
}
