Public Class IncCounterReadWriteClear

    Private CounterOptions0 As ArrayList = New ArrayList()
    Private CounterOptions1 As ArrayList = New ArrayList()
    Private MX_Common As MXCommon_WebReference.MXCommon
    Private MSXE371x As MSXE371x_WebReference.MSXE371x
    Private Response As MSXE371x_WebReference.DefaultResponse
    Private RetValue As Integer = 0
    Private syserno As Integer = 0
    Private ulCounterValue As System.UInt64 = 0
    Private ulTimeStampHigh As System.UInt64 = 0
    Private ulTimeStampLow As System.UInt64 = 0

    Public Class ListData
        Private myItem As String
        Private myValue As Long

        Public Sub New(ByVal strItem As String, ByVal lValue As Long)

            Me.myItem = strItem
            Me.myValue = lValue
        End Sub

        Public ReadOnly Property Item() As String
            Get
                Return myItem
            End Get
        End Property

        Public ReadOnly Property Value() As Long
            Get
                Return myValue
            End Get
        End Property
    End Class

    Public Shared Function ConvertFromTime_T(ByVal time_t As Long) As DateTime
        Dim dt70 As New DateTime(1970, 1, 1, 0, 0, 0, 0)
        Dim tickTotal As Long = dt70.Ticks + (time_t * 10000000)
        Dim netTimeT = New DateTime(tickTotal)
        Return netTimeT
    End Function

    Private Sub LB_IC_Mode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_IC_Mode.SelectedIndexChanged
        If Convert.ToUInt32(LB_IC_Mode.SelectedValue) = 0 Then
            LB_IC_Option.DataSource = CounterOptions1
        Else
            LB_IC_Option.DataSource = CounterOptions0
        End If
    End Sub

    Private Sub IncCounterReadWriteClear_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MX_Common = New MXCommon_WebReference.MXCommon()
        MSXE371x = New MSXE371x_WebReference.MSXE371x()
        MX_Common.Timeout = 2000
        MSXE371x.Timeout = 2000

        ' Counter mode list box initialisation

        Dim CounterModes As ArrayList = New ArrayList()
        CounterModes.Add(New ListData("Simple mode", 1))
        CounterModes.Add(New ListData("Double mode", 2))
        CounterModes.Add(New ListData("Quadruple mode", 4))
        CounterModes.Add(New ListData("Direct", 0))

        LB_IC_Mode.DisplayMember = "Item"
        LB_IC_Mode.ValueMember = "Value"
        LB_IC_Mode.DataSource = CounterModes

        ' Counter option list box initialisation

        CounterOptions0.Add(New ListData("Hysteresus on", 1))
        CounterOptions0.Add(New ListData("Hysteresus off", 0))
        CounterOptions1.Add(New ListData("Increment", 0))
        CounterOptions1.Add(New ListData("Decrement", 1))

        LB_IC_Option.DataSource = CounterOptions0
        LB_IC_Option.DisplayMember = "Item"
        LB_IC_Option.ValueMember = "Value"

        ' Counter compare mode list box initialisation

        Dim CompareModes As ArrayList = New ArrayList()
        CompareModes.Add(New ListData("Equals compare value", 0))
        CompareModes.Add(New ListData("Equals a multiple of the compare value", 1))

        LB_IC_CompareMode.DataSource = CompareModes
        LB_IC_CompareMode.DisplayMember = "Item"
        LB_IC_CompareMode.ValueMember = "Value"

        ' Counter compare options list box initialisation

        Dim CompareOptions As ArrayList = New ArrayList()
        CompareOptions.Add(New ListData("No synchro trigger used", 0))
        CompareOptions.Add(New ListData("Generates a synchro trigger", 1))

        LB_IC_SynchroTrigger.DataSource = CompareOptions
        LB_IC_SynchroTrigger.DisplayMember = "Item"
        LB_IC_SynchroTrigger.ValueMember = "Value"

    End Sub

    Private Sub IncCounterReadWriteClear_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If Not MSXE371x Is Nothing Then
            MSXE371x = Nothing
        End If
        If Not MX_Common Is Nothing Then
            MX_Common = Nothing
        End If

        System.GC.Collect()
    End Sub

    Private Sub IncCounterReadWriteClear_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        B_StopSample_Click(sender, Nothing)
    End Sub
    Private Sub B_StartSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StartSample.Click
        If (TB_IPAddress_0.Text.ToString() = "") Or (TB_IPAddress_1.Text.ToString() = "") Or (TB_IPAddress_2.Text.ToString() = "") Or (TB_IPAddress_3.Text.ToString() = "") Then
            MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256) Then
                If (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256) Then
                    If (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256) Then
                        If (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256) Then
                            MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555"
                            MSXE371x.Url = MX_Common.Url

                            Try
                                ' External temperature initialisation

                                RetValue = MSXE371x.IncCounterInit(Convert.ToUInt32(LB_IC_Mode.SelectedValue), _
                                                                   Convert.ToUInt32(LB_IC_Option.SelectedValue), _
                                                                   0, 0, 0, 0, syserno)
                                If RetValue <> 0 Then
                                    MessageBox.Show("IncCounterInit Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                Else
                                    T_ReadValue.Enabled = True
                                    B_StartSample.Enabled = False
                                    B_StopSample.Enabled = True
                                    GB_Counter.Enabled = False
                                    B_IC_ClearCounter.Enabled = True
                                    B_IC_WriteCounter.Enabled = True
                                    b_IC_InitCompare.Enabled = True
                                    TB_IC_WriteCounter.Enabled = True
                                End If
                            Catch ex As Exception
                                MessageBox.Show("IncCounterInit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            End Try
                        Else
                            MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    Else
                        MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Else
                MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub B_StopSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StopSample.Click
        If B_IC_ReleaseCompare.Enabled = True Then
            B_IC_ReleaseCompare_Click(sender, e)
        End If

        If B_StopSample.Enabled = True Then
            Try
                ' Counter compare initialisation

                RetValue = MSXE371x.IncCounterRelease(syserno)
                If RetValue <> 0 Then
                    MessageBox.Show("IncCounterRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Else
                    T_ReadValue.Enabled = False
                    B_StartSample.Enabled = True
                    B_StopSample.Enabled = False
                    GB_Counter.Enabled = True
                    B_IC_ClearCounter.Enabled = False
                    B_IC_WriteCounter.Enabled = False
                    b_IC_InitCompare.Enabled = False
                    TB_IC_WriteCounter.Enabled = False
                End If
            Catch ex As Exception
                MessageBox.Show("IncCounterRelease Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub

    Private Sub b_IC_InitCompare_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_IC_InitCompare.Click

        If (Convert.ToInt64(TB_IC_CompareValue.Text) >= 1) And (Convert.ToUInt64(TB_IC_CompareValue.Text) <= &HFFFFFFFFL) Then
            Try
                ' Counter compare initialisation

                RetValue = MSXE371x.IncCounterInitAndEnableCompareLogic(Convert.ToUInt64(TB_IC_CompareValue.Text), _
                                                                        Convert.ToUInt32(LB_IC_CompareMode.SelectedValue), _
                                                                        Convert.ToUInt32(LB_IC_SynchroTrigger.SelectedValue), _
                                                                        0, 0, syserno)
                If RetValue <> 0 Then
                    MessageBox.Show("IncCounterInitAndEnableCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Else
                    b_IC_InitCompare.Enabled = False
                    B_IC_ReleaseCompare.Enabled = True
                    GB_CounterCompare.Enabled = False
                End If
            Catch ex As Exception
                MessageBox.Show("IncCounterInitAndEnableCompareLogic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        Else
            MessageBox.Show("The compare value to write must be comprised between 1 and 4294967295.", "Parameter error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub B_IC_ReleaseCompare_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_IC_ReleaseCompare.Click
        Try
            ' Release the counter compare logic

            RetValue = MSXE371x.IncCounterDisableAndReleaseCompareLogic(syserno)
            If RetValue <> 0 Then
                MessageBox.Show("IncCounterDisableAndReleaseCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        Catch ex As Exception
            MessageBox.Show("IncCounterDisableAndReleaseCompareLogic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

        b_IC_InitCompare.Enabled = True
        B_IC_ReleaseCompare.Enabled = False
        GB_CounterCompare.Enabled = True
    End Sub

    Private Sub B_IC_ClearCounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_IC_ClearCounter.Click
        Try
            ' Clear the counter value

            RetValue = MSXE371x.IncCounterClear(syserno)
            If RetValue <> 0 Then
                MessageBox.Show("IncCounterClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        Catch ex As Exception
            MessageBox.Show("IncCounterClear Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub B_IC_WriteCounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_IC_WriteCounter.Click
        Try
            ' Write the counter value

            RetValue = MSXE371x.IncCounterWrite32BitValue(Convert.ToUInt64(TB_IC_WriteCounter.Text), syserno)
            If RetValue <> 0 Then
                MessageBox.Show("IncCounterWrite32BitValue Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        Catch ex As Exception
            MessageBox.Show("IncCounterWrite32BitValue Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub T_ReadValue_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles T_ReadValue.Tick
        Dim ulTimeStampLowmus As UInt64 = 0
        Dim ulTimeStampLowms As UInt64 = 0
        Dim sTimeStamp As String

        Try
            ' Read the counter value

            Response = MSXE371x.IncCounterRead32BitValue(ulCounterValue, ulTimeStampLow, ulTimeStampHigh)
            If Response.iReturnValue <> 0 Then
                MessageBox.Show("IncCounterRead32BitValue Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Else
                ulTimeStampLowms = CType((ulTimeStampLow / 1000), System.UInt64)
                ulTimeStampLowmus = CType((ulTimeStampLow Mod 1000), System.UInt64)
                sTimeStamp = "Time stamp: " + ConvertFromTime_T(CType(ulTimeStampHigh, Long)).ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3")

                L_CounterInfo.Text = "Counter = " + ulCounterValue.ToString() + " (dec). " + sTimeStamp
            End If
        Catch ex As Exception
            MessageBox.Show("IncCounterRead32BitValue Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

End Class
