Imports System
Imports System.Threading
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Net
Imports System.Net.Sockets
Imports AddiData.ADDIControls
Imports AddiData.ADDISocket
Imports AddiData

Public Class TransducerAutoRefresh

    Private MX_Common As MXCommon_WebReference.MXCommon
    Private MSXE371x As MSXE371x_WebReference.MSXE371x
    Private MXResponse As MXCommon_WebReference.DefaultResponse
    Private Response As MSXE371x_WebReference.DefaultResponse
    Private CounterOptions0 As New ArrayList
    Private CounterOptions1 As New ArrayList
    Private RetValue As Integer
    Private syserno As Integer
    Private TranducerInformations() As TranducerInfo
    Private AutoRefreshChannels(7) As CheckBox
    Private DataFrame(4) As CheckBox
    Private SocketClient As Socket
    Private Client As AddiData.ADDISocket.AsyncClientStream = Nothing
    Private acReadCallBack As AsyncCallback
    Private boExternalTempInit As Boolean = False
    Private boCounterInit As Boolean = False
    Private boCounterCompareInit As Boolean = False
    Private boAutoRefreshInit As Boolean = False
    Private boSaveGB_Thermocouple As Boolean = False
    Private boSaveGB_Counter As Boolean = False
    Private boSaveGB_CounterCompare As Boolean = False
    Private iDataStreamSize As Integer = 0
    Private ulTFormat As System.UInt64 = 0
    Private sRefreshOutString As String
    Private alAcquisitionChannels As ArrayList
    Private iMaxFrameSize As Integer = 0
    Private ulChannelMask As System.UInt64


    Public Class ListData
        Private myItem As String
        Private myValue As Long

        Public Sub New(ByVal strItem As String, ByVal lValue As Long)

            Me.myItem = strItem
            Me.myValue = lValue
        End Sub

        Public ReadOnly Property Item() As String
            Get
                Return myItem
            End Get
        End Property

        Public ReadOnly Property Value() As Long
            Get
                Return myValue
            End Get
        End Property
    End Class

    Public Function ConvertFromTime_T(ByVal bBuffer() As Byte, ByVal iIndex As Integer) As String

        Dim ulTimeStampHigh As System.UInt64 = BitConverter.ToUInt32(bBuffer, iIndex)
        Dim ulTimeStampLow As System.UInt64 = BitConverter.ToUInt32(bBuffer, iIndex + 4)

        Return (ConvertFromTime_T(ulTimeStampHigh, ulTimeStampLow))
    End Function

    Public Function ConvertFromTime_T(ByVal time_t As Long) As DateTime
        Dim dt70 As DateTime = New DateTime(1970, 1, 1, 0, 0, 0, 0)
        Dim tickTotal As Long = dt70.Ticks + (time_t * 10000000L)

        Dim netTimeT As DateTime = New DateTime(tickTotal)

        Return (netTimeT)
    End Function

    Public Function ConvertFromTime_T(ByVal ulTimeStampHigh As System.UInt64, ByVal ulTimeStampLow As System.UInt64) As String
        Dim ulTimeStampLowms As System.UInt64 = CType((ulTimeStampLow / 1000), System.UInt64)
        Dim ulTimeStampLowmus As System.UInt64 = CType((ulTimeStampLow Mod 1000), System.UInt64)

        Dim dt70 = New DateTime(1970, 1, 1, 0, 0, 0, 0)
        Dim tickTotal As Long = dt70.Ticks + CType((ulTimeStampHigh * 10000000L), Long)
        Dim netTimeT = New DateTime(tickTotal)
        Return (netTimeT.ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3"))
    End Function

    Public Function ulGetNbrOfTransducerChannel(ByVal sModuleType As String) As UInt64
        If (sModuleType.IndexOf("-", 0) = -1) Then
            Return 0
        End If

        sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1)

        If (sModuleType.IndexOf("-", 0) = -1) Then
            Return 0
        End If
        sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1)

        If (sModuleType.IndexOf("-", 0) = -1) Then
            Return 0
        End If

        sModuleType = sModuleType.Remove(sModuleType.IndexOf("-", 0))

        Return (Convert.ToUInt64(sModuleType))
    End Function

    Public Class TranducerInfo
        Private ulSelectionIndex As System.UInt64
        Private sName As String
        Private ulCalibrationStatus As System.UInt64
        Private ulCalibratedChannels As System.UInt64
        Private ulType As System.UInt64
        Private ulFrequency As System.UInt64
        Private ulImpedance As System.UInt64
        Private dVeff As Double
        Private dSensibility As Double
        Private dRange As Double

        Public Sub New(ByVal SelectionIndex As ULong, _
                       ByVal Name As String, _
                       ByVal CalibrationStatus As ULong, _
                       ByVal CalibratedChannels As ULong, _
                       ByVal Type As ULong, _
                       ByVal Frequency As ULong, _
                       ByVal Impedance As ULong, _
                       ByVal Veff As Double, _
                       ByVal Sensibility As Double, _
                       ByVal Range As Double)
            ulSelectionIndex = SelectionIndex
            sName = Name.Remove(Name.IndexOf(Chr(0)))
            ulCalibrationStatus = CalibrationStatus
            ulCalibratedChannels = CalibratedChannels
            ulType = Type
            ulFrequency = Frequency
            ulImpedance = Impedance
            dVeff = Veff
            dSensibility = Sensibility
            dRange = Range
        End Sub

        Public Property SelectionIndex() As System.UInt64
            Get
                Return (ulSelectionIndex)
            End Get
            Set(ByVal Value As System.UInt64)
                ulSelectionIndex = Value
            End Set
        End Property
        Public Property CalibrationStatus() As System.UInt64
            Get
                Return (ulCalibrationStatus)
            End Get
            Set(ByVal Value As System.UInt64)
                ulCalibrationStatus = Value
            End Set
        End Property
        Public Property CalibratedChannels() As System.UInt64
            Get
                Return (ulCalibratedChannels)
            End Get
            Set(ByVal Value As System.UInt64)
                ulCalibratedChannels = Value
            End Set
        End Property
        Public Property Type() As System.UInt64
            Get
                Return (ulType)
            End Get
            Set(ByVal Value As System.UInt64)
                ulType = Value
            End Set
        End Property
        Public Property Frequency() As System.UInt64
            Get
                Return (ulFrequency)
            End Get
            Set(ByVal Value As System.UInt64)
                ulFrequency = Value
            End Set
        End Property
        Public Property Impedance() As System.UInt64
            Get
                Return (ulImpedance)
            End Get
            Set(ByVal Value As System.UInt64)
                ulImpedance = Value
            End Set
        End Property
        Public Property Veff() As Double
            Get
                Return (dVeff)
            End Get
            Set(ByVal Value As Double)
                dVeff = Value
            End Set
        End Property
        Public Property Sensibility() As Double
            Get
                Return (dSensibility)
            End Get
            Set(ByVal Value As Double)
                dSensibility = Value
            End Set
        End Property
        Public Property Range() As Double
            Get
                Return (dRange)
            End Get
            Set(ByVal Value As Double)
                dRange = Value
            End Set
        End Property
        Public Property Name() As String
            Get
                Return (sName)
            End Get
            Set(ByVal Value As String)
                sName = Value
            End Set
        End Property

        Public Overrides Function ToString() As String
            Dim sRet As String

            sRet = "Transducer Selection Index : " + ulSelectionIndex.ToString()
            sRet = sRet + Environment.NewLine + "Name                                   : " + sName
            sRet = sRet + Environment.NewLine + "Calibration status                  : " + ulCalibrationStatus.ToString()
            sRet = sRet + Environment.NewLine + "Type Value                          : " + ulType.ToString()
            sRet = sRet + Environment.NewLine + "Frequency                           : " + ulFrequency.ToString() + " Hz"
            sRet = sRet + Environment.NewLine + "Impedance                          : " + ulImpedance.ToString() + " Ohm"
            sRet = sRet + Environment.NewLine + "Nominal Voltage                  : " + dVeff.ToString() + " V"
            sRet = sRet + Environment.NewLine + "Sensibility                            : " + dSensibility.ToString() + " mV/V/mm"
            sRet = sRet + Environment.NewLine + "Range                                 : +/-" + dRange.ToString() + " mm"

            Return (sRet)
        End Function
    End Class

    Private Sub TransducerAutoRefresh_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If Not MSXE371x Is Nothing Then
            MSXE371x = Nothing
        End If
        If Not MX_Common Is Nothing Then
            MX_Common = Nothing
        End If

        System.GC.Collect()
    End Sub

    Private Sub TransducerAutoRefresh_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        B_StopSample_Click(sender, Nothing)
    End Sub


    Private Sub TransducerAutoRefresh_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MX_Common = New MXCommon_WebReference.MXCommon()
        MSXE371x = New MSXE371x_WebReference.MSXE371x()
        MX_Common.Timeout = 5000
        MSXE371x.Timeout = 5000

        ' Thermocouple list box initialisation
        Dim Thermocouples = New ArrayList()
        Thermocouples.Add(New ListData("PT100", 100))
        Thermocouples.Add(New ListData("PT200", 200))
        Thermocouples.Add(New ListData("PT500", 500))
        Thermocouples.Add(New ListData("PT1000", 1000))

        LB_T_Thermocouple.DisplayMember = "Item"
        LB_T_Thermocouple.ValueMember = "Value"
        LB_T_Thermocouple.DataSource = Thermocouples

        ' Gain list box initialisation
        Dim Gains = New ArrayList()
        Gains.Add(New ListData("Auto mode", 0))

        LB_T_Gain.DisplayMember = "Item"
        LB_T_Gain.ValueMember = "Value"
        LB_T_Gain.DataSource = Gains

        ' Frequency list box initialisation
        Dim Frequencys = New ArrayList()
        Frequencys.Add(New ListData("10 Hz", 10))
        Frequencys.Add(New ListData("240 Hz", 240))

        LB_T_Frequency.DisplayMember = "Item"
        LB_T_Frequency.ValueMember = "Value"
        LB_T_Frequency.DataSource = Frequencys

        ' Display format list box initialisation
        Dim Formats = New ArrayList()
        Formats.Add(New ListData("mOhm", 0))
        Formats.Add(New ListData("C", 1))
        Formats.Add(New ListData("F", 2))

        LB_T_Format.DisplayMember = "Item"
        LB_T_Format.ValueMember = "Value"
        LB_T_Format.DataSource = Formats

        ' Counter mode list box initialisation
        Dim CounterModes = New ArrayList()
        CounterModes.Add(New ListData("Simple mode", 1))
        CounterModes.Add(New ListData("Double mode", 2))
        CounterModes.Add(New ListData("Quadruple mode", 4))
        CounterModes.Add(New ListData("Direct", 0))

        LB_IC_Mode.DisplayMember = "Item"
        LB_IC_Mode.ValueMember = "Value"
        LB_IC_Mode.DataSource = CounterModes

        ' Counter option list box initialisation
        CounterOptions0.Add(New ListData("Hysteresus on", 1))
        CounterOptions0.Add(New ListData("Hysteresus off", 0))
        CounterOptions1.Add(New ListData("Increment", 0))
        CounterOptions1.Add(New ListData("Decrement", 1))

        LB_IC_Option.DisplayMember = "Item"
        LB_IC_Option.ValueMember = "Value"
        LB_IC_Option.DataSource = CounterOptions0

        ' Counter compare mode list box initialisation
        Dim CompareModes = New ArrayList()
        CompareModes.Add(New ListData("Disabled", -1))
        CompareModes.Add(New ListData("Equals compare value", 0))
        CompareModes.Add(New ListData("Equals a multiple of the compare value", 1))

        LB_IC_CompareMode.DisplayMember = "Item"
        LB_IC_CompareMode.ValueMember = "Value"
        LB_IC_CompareMode.DataSource = CompareModes

        ' Counter compare options list box initialisation
        Dim CompareOptions = New ArrayList()
        CompareOptions.Add(New ListData("No synchro trigger used", 0))
        CompareOptions.Add(New ListData("Generates a synchro trigger", 1))

        LB_IC_SynchroTrigger.DisplayMember = "Item"
        LB_IC_SynchroTrigger.ValueMember = "Value"
        LB_IC_SynchroTrigger.DataSource = CompareOptions

        ' Average mode list box initialisation
        Dim AverageOptions = New ArrayList()
        AverageOptions.Add(New ListData("Disabled", 0))
        AverageOptions.Add(New ListData("Enabled", 1))

        LB_AverageMode.DisplayMember = "Item"
        LB_AverageMode.ValueMember = "Value"
        LB_AverageMode.DataSource = AverageOptions

        ' Trigger source list box initialisation
        Dim TriggerSources = New ArrayList()
        TriggerSources.Add(New ListData("Disabled", 0))
        TriggerSources.Add(New ListData("Hardware trigger", 1))
        TriggerSources.Add(New ListData("Synchro trigger", 2))
        TriggerSources.Add(New ListData("Counter compare trigger", 4))

        LB_TriggerSource.DisplayMember = "Item"
        LB_TriggerSource.ValueMember = "Value"
        LB_TriggerSource.DataSource = TriggerSources


        ' Trigger mode list box initialisation
        Dim TriggerModes = New ArrayList()
        TriggerModes.Add(New ListData("One shot trigger", 1))
        TriggerModes.Add(New ListData("Sequence trigger", 2))

        LB_TriggerMode.DisplayMember = "Item"
        LB_TriggerMode.ValueMember = "Value"
        LB_TriggerMode.DataSource = TriggerModes


        ' HW Trigger edge list box initialisation
        Dim HWTriggerEdges = New ArrayList()
        HWTriggerEdges.Add(New ListData("Rising edge", 1))
        HWTriggerEdges.Add(New ListData("Falling edge", 2))
        HWTriggerEdges.Add(New ListData("Both front", 3))

        LB_HWEdge.DisplayMember = "Item"
        LB_HWEdge.ValueMember = "Value"
        LB_HWEdge.DataSource = HWTriggerEdges

        ' Save the auto refresh channels check box
        AutoRefreshChannels(0) = CB_Channel0
        AutoRefreshChannels(1) = CB_Channel1
        AutoRefreshChannels(2) = CB_Channel2
        AutoRefreshChannels(3) = CB_Channel3
        AutoRefreshChannels(4) = CB_Channel4
        AutoRefreshChannels(5) = CB_Channel5
        AutoRefreshChannels(6) = CB_Channel6
        AutoRefreshChannels(7) = CB_Channel7

        ' Save the data frame check box
        DataFrame(0) = CB_DataFrameTimeStamp
        DataFrame(1) = CB_DataFrameMetric
        DataFrame(2) = CB_DataFrameInvert
        DataFrame(3) = CB_DataFrameTemperature
        DataFrame(4) = CB_DataFrameIncCounter
    End Sub

    Private Sub LB_IC_Mode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_IC_Mode.SelectedIndexChanged
        If (Convert.ToUInt32(LB_IC_Mode.SelectedValue) = 0) Then
            LB_IC_Option.DataSource = CounterOptions1
        Else
            LB_IC_Option.DataSource = CounterOptions0
        End If
    End Sub

    Private Sub LB_IC_CompareMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_IC_CompareMode.SelectedIndexChanged
        TB_IC_CompareValue.Enabled = Convert.ToBoolean(Convert.ToInt32(LB_IC_CompareMode.SelectedValue) <> -1)
        LB_IC_SynchroTrigger.Enabled = TB_IC_CompareValue.Enabled
    End Sub
    Private Function bo_ThermocoupleInitialisation() As Boolean
        Dim bo_Ret As Boolean = True

        If (GB_Thermocouple.Enabled = True) Then
            Try
                ' External temperature initialisation

                RetValue = MSXE371x.ExternalTemperatureInit(Convert.ToUInt32(LB_T_Thermocouple.SelectedValue), _
                                                            Convert.ToUInt32(LB_T_Format.SelectedValue), _
                                                            Convert.ToUInt32(LB_T_Gain.SelectedValue), _
                                                            Convert.ToUInt32(LB_T_Frequency.SelectedValue), _
                                                            0, 0, 0, 0, 0, syserno)
                If (RetValue <> 0) Then
                    MessageBox.Show("ExternalTemperatureInit Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    bo_Ret = False
                Else
                    boExternalTempInit = True
                End If
            Catch ex As Exception
                MessageBox.Show("ExternalTemperatureInit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                bo_Ret = False
            End Try
        End If

        Return (bo_Ret)
    End Function

    Private Function bo_ThermocoupleRelease() As Boolean

        Dim bo_Ret As Boolean = True

        If (boExternalTempInit = True) Then
            Try
                ' Release external temperature

                RetValue = MSXE371x.ExternalTemperatureRelease(syserno)

                If (RetValue <> 0) Then
                    MessageBox.Show("ExternalTemperatureRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    bo_Ret = False
                End If
            Catch ex As Exception
                MessageBox.Show("ExternalTemperatureRelease Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                bo_Ret = False
            End Try

            boExternalTempInit = False
        End If

        Return (bo_Ret)
    End Function

    Private Function bo_CounterInitialisation() As Boolean


        Dim bo_Ret As Boolean = True

        If (GB_Counter.Enabled = True) Then
            Try
                ' Counter initialisation

                RetValue = MSXE371x.IncCounterInit(Convert.ToUInt32(LB_IC_Mode.SelectedValue), _
                                                   Convert.ToUInt32(LB_IC_Option.SelectedValue), _
                                                   0, 0, 0, 0, syserno)
                If (RetValue <> 0) Then
                    MessageBox.Show("IncCounterInit Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    bo_Ret = False
                Else
                    boCounterInit = True
                End If
            Catch ex As Exception
                MessageBox.Show("IncCounterInit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                bo_Ret = False
            End Try

            If ((bo_Ret = True) And (GB_CounterCompare.Enabled = True) And (Convert.ToInt32(LB_IC_CompareMode.SelectedValue) <> -1)) Then
                Try
                    ' Counter compare initialisation

                    RetValue = MSXE371x.IncCounterInitAndEnableCompareLogic(Convert.ToUInt64(TB_IC_CompareValue.Text), _
                                                                            Convert.ToUInt32(LB_IC_CompareMode.SelectedValue), _
                                                                            Convert.ToUInt32(LB_IC_SynchroTrigger.SelectedValue), _
                                                                            0, 0, syserno)
                    If (RetValue <> 0) Then
                        MessageBox.Show("IncCounterInitAndEnableCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        bo_Ret = False
                    Else
                        boCounterCompareInit = True
                    End If
                Catch ex As Exception
                    MessageBox.Show("IncCounterInitAndEnableCompareLogic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    bo_Ret = False
                End Try
            End If
        End If
        Return (bo_Ret)
    End Function

    Private Function bo_CounterRelease() As Boolean
        Dim bo_Ret As Boolean = True

        If (boCounterInit = True) Then
            If (boCounterCompareInit = True) Then
                Try
                    ' Release the counter compare logic

                    RetValue = MSXE371x.IncCounterDisableAndReleaseCompareLogic(syserno)
                    If (RetValue <> 0) Then
                        MessageBox.Show("IncCounterDisableAndReleaseCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        bo_Ret = False
                    End If
                Catch ex As Exception
                    MessageBox.Show("IncCounterDisableAndReleaseCompareLogic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    bo_Ret = False
                End Try

                boCounterCompareInit = False
            End If

            Try
                ' Counter compare release

                RetValue = MSXE371x.IncCounterRelease(syserno)
                If (RetValue <> 0) Then
                    MessageBox.Show("IncCounterRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    bo_Ret = False
                End If
            Catch ex As Exception
                MessageBox.Show("IncCounterRelease Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                bo_Ret = False
            End Try

            boCounterInit = False
        End If
        Return (bo_Ret)
    End Function

    Private Sub LB_TransducerList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_TransducerList.SelectedIndexChanged
        L_TransducerInfo.Text = TranducerInformations(LB_TransducerList.SelectedIndex).ToString()
    End Sub

    Private Sub LB_AverageMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_AverageMode.SelectedIndexChanged
        TB_AverageValue.Enabled = Convert.ToBoolean(LB_AverageMode.SelectedValue)
    End Sub

    Private Sub CB_DataFrameTemperature_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CB_DataFrameTemperature.CheckedChanged
        GB_Thermocouple.Enabled = CB_DataFrameTemperature.Checked
    End Sub

    Private Sub TriggerManagement()
        LB_TriggerMode.Enabled = Convert.ToBoolean(LB_TriggerSource.SelectedValue)
        TB_SequenceTrigger.Enabled = Convert.ToBoolean(LB_TriggerSource.SelectedValue) And Convert.ToBoolean(Convert.ToUInt32(LB_TriggerMode.SelectedValue) = 2)
        LB_HWEdge.Enabled = Convert.ToBoolean(Convert.ToUInt32(LB_TriggerSource.SelectedValue) = 1)
        TB_HTriggerCount.Enabled = Convert.ToBoolean(Convert.ToUInt32(LB_TriggerSource.SelectedValue) = 1)

        CounterManagement()
    End Sub

    Private Sub LB_TriggerSource_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_TriggerSource.SelectedIndexChanged
        TriggerManagement()
    End Sub

    Private Sub LB_TriggerMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_TriggerMode.SelectedIndexChanged
        TriggerManagement()
    End Sub

    Private Sub CounterManagement()

        GB_Counter.Enabled = CB_DataFrameIncCounter.Checked Or Convert.ToBoolean(Convert.ToUInt32(LB_TriggerSource.SelectedValue) = 4) Or Convert.ToBoolean(Convert.ToUInt32(LB_TriggerSource.SelectedValue) = 2)
        GB_CounterCompare.Enabled = GB_Counter.Enabled
    End Sub

    Private Sub CB_DataFrameIncCounter_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CB_DataFrameIncCounter.CheckedChanged
        CounterManagement()
    End Sub

    Private Sub B_Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_Connect.Click
        Dim enc = New System.Text.ASCIIEncoding()
        Dim pcName(255) As Byte
        Dim ulNbrOfTransducers As System.UInt64
        Dim ulNbrOfChannels As System.UInt64
        Dim ulSelectionIndex As System.UInt64
        Dim ulCalibrationStatus As System.UInt64
        Dim ulCalibratedChannels As System.UInt64
        Dim ulType As System.UInt64
        Dim ulFrequency As System.UInt64
        Dim ulImpedance As System.UInt64
        Dim dVeff As Double
        Dim dSensibility As Double
        Dim dRange As Double

        If ((TB_IPAddress_0.Text.ToString() = "") Or (TB_IPAddress_1.Text.ToString() = "") Or (TB_IPAddress_2.Text.ToString() = "") Or (TB_IPAddress_3.Text.ToString() = "")) Then
            MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256)) Then
                If ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256)) Then
                    If ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256)) Then
                        If ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256)) Then
                            B_StartSample.Enabled = False
                            MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555"
                            MSXE371x.Url = MX_Common.Url

                            Try
                                ' Get the number of transducers type

                                Response = MSXE371x.TransducerGetNbrOfType(ulNbrOfTransducers)
                                If (Response.iReturnValue <> 0) Then
                                    MessageBox.Show("TransducerGetNbrOfType Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                    Return
                                End If
                            Catch ex As Exception
                                MessageBox.Show("TransducerGetNbrOfType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                Return
                            End Try

                            ReDim TranducerInformations(ulNbrOfTransducers)
                            Dim Transducers = New ArrayList()
                            L_NbrOfTransducers.Text = ulNbrOfTransducers.ToString()

                            Dim ulCpt As System.UInt64
                            For ulCpt = 0 To ulNbrOfTransducers - 1
                                ' Get the transducer informations
                                MSXE371x.TransducerGetTypeInformation(ulCpt, _
                                                                       ulSelectionIndex, _
                                                                       pcName, _
                                                                       ulCalibrationStatus, _
                                                                       ulCalibratedChannels, _
                                                                       ulType, _
                                                                       ulFrequency, _
                                                                       ulImpedance, _
                                                                       dVeff, _
                                                                       dSensibility, _
                                                                       dRange)

                                ' Save the transducer informations
                                TranducerInformations(ulCpt) = New TranducerInfo(ulSelectionIndex, _
                                                                                 enc.GetString(pcName), _
                                                                                 ulCalibrationStatus, _
                                                                                 ulCalibratedChannels, _
                                                                                 ulType, _
                                                                                 ulFrequency, _
                                                                                 ulImpedance, _
                                                                                 dVeff, _
                                                                                 dSensibility, _
                                                                                 dRange)

                                Transducers.Add(New ListData(enc.GetString(pcName), CType(ulSelectionIndex, Long)))
                            Next

                            LB_TransducerList.DataSource = Transducers
                            LB_TransducerList.DisplayMember = "Item"
                            LB_TransducerList.ValueMember = "Value"

                            ' Get the module type
                            MXResponse = MX_Common.GetModuleType(pcName)
                            ulNbrOfChannels = ulGetNbrOfTransducerChannel(enc.GetString(pcName))


                            Dim i As System.UInt64
                            For i = 0 To ulNbrOfChannels - 1
                                AutoRefreshChannels(i).Enabled = True
                                AutoRefreshChannels(i).Checked = True
                            Next

                            For i = ulNbrOfChannels To 8 - 1
                                AutoRefreshChannels(i).Enabled = False
                                AutoRefreshChannels(i).Checked = False
                            Next

                            GB_Transducers.Enabled = True
                            B_StartSample.Enabled = True
                            GB_AutoRefresh.Enabled = True
                            GB_DataFormat.Enabled = True
                            GB_TriggerConfiguration.Enabled = True
                            B_StartSample.Enabled = True
                            GB_AcquisitionMode.Enabled = True

                        Else
                            MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    Else
                        MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Else
                MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Function boCheckConfiguration(ByRef ulChannelMask As ULong, ByRef ulDataFormat As ULong, ByRef iDataStreamSize As Integer) As Boolean
        Dim ulChannels As ULong = 0

        ulChannelMask = 0
        ulDataFormat = 0
        iDataStreamSize = 0

        ' Check the channel mask
        alAcquisitionChannels = New ArrayList()
        Dim i As Integer
        For i = 0 To 8 - 1 Step i + 1
            ulChannelMask = ulChannelMask Or (Convert.ToUInt32(AutoRefreshChannels(i).Checked) << i)
            ulChannels = ulChannels + Convert.ToUInt32(AutoRefreshChannels(i).Checked)

            If (AutoRefreshChannels(i).Checked = True) Then
                alAcquisitionChannels.Add("Channel " + i.ToString() + ":")
            End If
        Next

        If (ulChannelMask = 0) Then
            MessageBox.Show("No channel selected", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return (False)
        End If

        ' Check the average value
        If ((TB_AverageValue.Enabled = True) And ((Convert.ToInt32(TB_AverageValue.Text) < 1) Or (Convert.ToInt32(TB_AverageValue.Text) > 255))) Then
            MessageBox.Show("Average value selection error (0 < value < 256)", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return (False)
        End If

        ' Check the hardware trigger sequence number
        If ((TB_SequenceTrigger.Enabled = True) And ((Convert.ToInt64(TB_SequenceTrigger.Text) < 1) Or (Convert.ToInt64(TB_SequenceTrigger.Text) > &HFFFFFFFFL))) Then
            MessageBox.Show("Selection of sequence number to acquire for each trigger is wrong (0 < value <= 0xFFFFFFFF)", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return (False)
        End If

        ' Check the counter compare configuration
        If ((Convert.ToUInt32(LB_TriggerSource.SelectedValue) = 4) And (Convert.ToInt32(LB_IC_CompareMode.SelectedValue) = -1)) Then
            MessageBox.Show("Counter compare logic used for trigger but counter compare not configurated", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return (False)
        End If

        If ((TB_IC_CompareValue.Enabled = True) And ((Convert.ToInt64(TB_IC_CompareValue.Text) < 0) Or (Convert.ToInt64(TB_IC_CompareValue.Text) > &HFFFFFFFFL))) Then
            MessageBox.Show("Counter compare value selection error (0 <= value <= 0xFFFFFFFF)", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return (False)
        End If

        ' Get the data frame format
        For i = 0 To DataFrame.Length - 1
            ulDataFormat = ulDataFormat Or (Convert.ToUInt64(DataFrame(i).Checked) << i)
        Next

        ' Get the data strem size
        iDataStreamSize = Convert.ToInt32(4 + (ulChannels * 4) + _
                                          (Convert.ToUInt32(CB_DataFrameTimeStamp.Checked) * 8) + _
                                          (Convert.ToUInt32(CB_DataFrameTemperature.Checked) * 4) + _
                                          (Convert.ToUInt32(CB_DataFrameIncCounter.Checked) * 4))

        Return (True)
    End Function

    Private Sub B_StartSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StartSample.Click
        Dim ulDataFormat As System.UInt64
        Dim ClientThread As Thread

        ' Check the user configuration
        If (boCheckConfiguration(ulChannelMask, ulDataFormat, iDataStreamSize) = True) Then
            Try
                ulTFormat = Convert.ToUInt32(LB_T_Format.SelectedValue)

                ' Extern temperature initialisation
                If (bo_ThermocoupleInitialisation() = True) Then
                    ' Counter configuration
                    If (bo_CounterInitialisation() = True) Then
                        Try
                            SocketClient = Nothing
                            ClientThread = Nothing

                            ' Test if receive data via the data server
                            If (RB_DataServer.Checked = True) Then

                                ' Create the client stream 
                                Client = New AddiData.ADDISocket.AsyncClientStream()

                                ' DATA FORMAT CONFIGURATION
                                Client.SingleFramesSize = iDataStreamSize
                                Client.NbrOfFrames = 1


                                ' Open the socket connection to receive the data
                                SocketClient = New Net.Sockets.Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                                SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989)
                                SocketClient.ReceiveBufferSize = 1048576

                                ' Start the first read socket 
                                ' Start the read socket and the user thread
                                Client.Start(SocketClient)
                                ClientThread = New Thread(AddressOf ClientThreadFct)
                            End If

                            'Init and start the auto refresh acquisition
                            RetValue = MSXE371x.TransducerInitAndStartAutoRefresh(Convert.ToUInt64(LB_TransducerList.SelectedValue), _
                                                                                  ulChannelMask, _
                                                                                  Convert.ToUInt64(LB_AverageMode.SelectedValue), _
                                                                                  Convert.ToUInt64(TB_AverageValue.Text), _
                                                                                  Convert.ToUInt64(LB_TriggerSource.SelectedValue), _
                                                                                  Convert.ToUInt64(LB_TriggerMode.SelectedValue), _
                                                                                  Convert.ToUInt64(LB_HWEdge.SelectedValue), _
                                                                                  Convert.ToUInt64(TB_HTriggerCount.Text), _
                                                                                  Convert.ToUInt64(TB_SequenceTrigger.Text), _
                                                                                  ulDataFormat, _
                                                                                  0, 0, 0, 0, syserno)


                            If (RetValue <> 0) Then
                                MessageBox.Show("TransducerInitAndStartAutoRefresh Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Else
                                DisplayTimer.Enabled = True

                                ' Test if receive data via the data server
                                If (RB_DataServer.Checked = True) Then
                                    ClientThread.Priority = ThreadPriority.Lowest
                                    ClientThread.Start()
                                Else
                                    ReadTimer.Enabled = True
                                End If

                                boSaveGB_Thermocouple = GB_Thermocouple.Enabled
                                boSaveGB_Counter = GB_Counter.Enabled
                                boSaveGB_CounterCompare = GB_CounterCompare.Enabled
                                B_Connect.Enabled = False
                                GB_Transducers.Enabled = False
                                B_StartSample.Enabled = False
                                GB_AutoRefresh.Enabled = False
                                GB_DataFormat.Enabled = False
                                GB_TriggerConfiguration.Enabled = False
                                GB_Thermocouple.Enabled = False
                                GB_Counter.Enabled = False
                                GB_CounterCompare.Enabled = False
                                B_StopSample.Enabled = True
                                GB_AcquisitionMode.Enabled = False
                            End If
                        Catch ex As Exception
                            MessageBox.Show("TransducerInitAndStartAutoRefresh Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End Try
                    End If
                End If
            Catch ex As Exception
                MessageBox.Show("Socket connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try

            ' Test if error occur
            If (B_StartSample.Enabled = True) Then
                B_StopSample_Click(sender, e)
            End If
        End If
    End Sub

    Private Sub B_StopSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StopSample.Click

        DisplayTimer.Enabled = False
        ReadTimer.Enabled = False

        ' Test if socket open
        If (Not IsNothing(SocketClient)) Then
            If (Not IsNothing(Client)) Then
                Client.Stoop()
            End If

            Try
                ' Close the socket connection
                SocketClient.Disconnect(False)
                SocketClient.Close()
                SocketClient = Nothing
                System.GC.Collect()

            Catch ex As Exception
                MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If

        ' Test if auto refresh started
        If (B_StartSample.Enabled = False) Then
            boAutoRefreshInit = False
            B_Connect.Enabled = True
            GB_Transducers.Enabled = True
            B_StartSample.Enabled = True
            GB_AutoRefresh.Enabled = True
            GB_DataFormat.Enabled = True
            GB_TriggerConfiguration.Enabled = True
            GB_Thermocouple.Enabled = boSaveGB_Thermocouple
            GB_Counter.Enabled = boSaveGB_Counter
            GB_CounterCompare.Enabled = boSaveGB_CounterCompare
            GB_AcquisitionMode.Enabled = True

            Try
                ' Release the counter compare logic

                RetValue = MSXE371x.TransducerStopAndReleaseAutoRefresh(syserno)
                If (RetValue <> 0) Then
                    MessageBox.Show("TransducerStopAndReleaseAutoRefresh Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Catch ex As Exception
                MessageBox.Show("TransducerStopAndReleaseAutoRefresh Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If

        B_StartSample.Enabled = True
        B_StopSample.Enabled = False

        bo_ThermocoupleRelease()
        bo_CounterRelease()
    End Sub

    Private Sub ReadTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadTimer.Tick
        Dim Values(8) As ULong
        Dim sOutString As String
        Dim Cpt As Integer
        Dim iChannelsCpt As Integer
        Dim TestChannel As ULong
        Dim TimeStampLow As ULong
        Dim TimeStampHigh As ULong
        Dim TimeStampLowmus As ULong
        Dim TimeStampLowms As ULong
        Dim IncCounter As ULong
        Dim CounterValue As ULong
        Dim ExternalTemperature As ULong
        Dim pResponse As MSXE371x_WebReference.DefaultResponse

        ' Read the auto refresh value
        pResponse = MSXE371x.TransducerGetAllAutoRefreshValues(CounterValue, Values, TimeStampLow, TimeStampHigh, IncCounter, ExternalTemperature)

        ' Test if error occur
        If ((pResponse.iReturnValue <> 0) Or (pResponse.syserrno <> 0)) Then
            B_StopSample_Click(sender, Nothing)
            MessageBox.Show("TransducerGetAllAutoRefreshValues Error : " + pResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            sOutString = ""

            ' Test if time stampe
            If (CB_DataFrameTimeStamp.Checked = True) Then
                TimeStampLowms = TimeStampLow / 1000
                TimeStampLowmus = TimeStampLow Mod 1000
                sOutString = "Time stamp: " + ConvertFromTime_T(TimeStampHigh).ToString() + "." + TimeStampLowms.ToString("D3") + "." + TimeStampLowmus.ToString("D3")
            End If

            ' Test if external temperature used
            If (CB_DataFrameTemperature.Checked = True) Then
                If (sOutString <> "") Then
                    sOutString = sOutString + " / "
                End If
                ' Test if mOhm
                If (ulTFormat = 0) Then
                    sOutString = sOutString + "External temperature: " + ExternalTemperature.ToString() + " mOhm"
                    'Test if C
                ElseIf (ulTFormat = 1) Then
                    sOutString = sOutString + "External temperature: " + BitConverter.ToSingle(BitConverter.GetBytes(ExternalTemperature), 0).ToString("F3") + " C"
                    ' F
                Else
                    sOutString = sOutString + "External temperature: " + BitConverter.ToSingle(BitConverter.GetBytes(ExternalTemperature), 0).ToString("F3") + " F"
                End If
            End If

            ' Test if incremental counter used
            If (CB_DataFrameIncCounter.Checked = True) Then
                If (sOutString <> "") Then
                    sOutString = sOutString + " / "
                End If

                sOutString = sOutString + "Incremental counter : " + IncCounter.ToString() + " Dec"
            End If

            If (sOutString <> "") Then
                sOutString = sOutString + Environment.NewLine
            End If

            ' Get the auto refresh counter value
            sOutString = sOutString + "Auto refresh counter: " + CounterValue.ToString()

            ' Get the auto refresh channel mask
            TestChannel = 1
            iChannelsCpt = 0

            For Cpt = 0 To 7
                ' Test if channel used
                If ((ulChannelMask And TestChannel) <> 0) Then
                    If ((iChannelsCpt Mod 4) = 0) Then
                        sOutString = sOutString + Environment.NewLine
                    End If

                    ' Test if mm
                    If (CB_DataFrameMetric.Checked = True) Then
                        sOutString = sOutString + alAcquisitionChannels(iChannelsCpt) + BitConverter.ToSingle(BitConverter.GetBytes(Values(Cpt)), 0).ToString("F3") + " mm  "
                    Else
                        sOutString = sOutString + alAcquisitionChannels(iChannelsCpt) + BitConverter.ToUInt32(BitConverter.GetBytes(Values(Cpt)), 0).ToString("X") + " Hex  "
                    End If

                    iChannelsCpt = iChannelsCpt + 1
                End If

                TestChannel = TestChannel * 2
            Next Cpt

            sRefreshOutString = sOutString
        End If
    End Sub

    Private Sub ClientThreadFct()
        Dim sOutString As String
        Dim sAutoRefresh As String
        Dim iSocketDataIndex As Integer
        Dim iFrameSize As Integer = 0
        Dim SocketData(Client.SingleFramesSize) As Byte

        While (True)
            SocketData = Client.ReadData()

            If (Not IsNothing(SocketData)) Then
                sOutString = ""
                iSocketDataIndex = 0
                sOutString = ""

                ' Test if time stampe
                If (CB_DataFrameTimeStamp.Checked = True) Then
                    sOutString = "Time stamp: " + ConvertFromTime_T(SocketData, iSocketDataIndex)
                    iSocketDataIndex = iSocketDataIndex + 8
                End If

                ' Get the auto refresh counter value
                sAutoRefresh = "Auto refresh counter: " + BitConverter.ToUInt32(SocketData, iSocketDataIndex).ToString()
                iSocketDataIndex = iSocketDataIndex + 4

                ' Test if external temperature used
                If (CB_DataFrameTemperature.Checked = True) Then
                    If (sOutString <> "") Then
                        sOutString = sOutString + " / "
                    End If
                    ' Test if mOhm
                    If (ulTFormat = 0) Then
                        sOutString = sOutString + "External temperature: " + BitConverter.ToUInt32(SocketData, iSocketDataIndex).ToString() + " mOhm"
                        ' Test if C
                    ElseIf (ulTFormat = 1) Then
                        sOutString = sOutString + "External temperature: " + BitConverter.ToSingle(SocketData, iSocketDataIndex).ToString("F3") + " C"
                        ' F
                    Else
                        sOutString = sOutString + "External temperature: " + BitConverter.ToSingle(SocketData, iSocketDataIndex).ToString("F3") + " F"
                    End If

                    iSocketDataIndex = iSocketDataIndex + 4
                End If

                ' Test if incremental counter used
                If (CB_DataFrameIncCounter.Checked = True) Then
                    If (sOutString <> "") Then
                        sOutString = sOutString + " / "
                    End If

                    sOutString = sOutString + "Incremental counter : " + BitConverter.ToUInt32(SocketData, iSocketDataIndex).ToString() + " Dec"
                    iSocketDataIndex = iSocketDataIndex + 4
                End If

                If (sOutString <> "") Then
                    sOutString = sOutString + Environment.NewLine + sAutoRefresh
                Else
                    sOutString = sAutoRefresh
                End If

                ' Get the transducer channels value
                Dim iChannelsCpt As Integer = 0
                Dim Channel As String
                For Each Channel In alAcquisitionChannels
                    If ((iChannelsCpt Mod 4) = 0) Then
                        sOutString = sOutString + Environment.NewLine
                    End If

                    ' Test if mm
                    If (CB_DataFrameMetric.Checked = True) Then
                        sOutString = sOutString + Channel + BitConverter.ToSingle(SocketData, iSocketDataIndex).ToString("F3") + " mm  "
                    Else
                        sOutString = sOutString + Channel + BitConverter.ToUInt32(SocketData, iSocketDataIndex).ToString("X") + " Hex  "
                    End If
                    iSocketDataIndex = iSocketDataIndex + 4
                    iChannelsCpt = iChannelsCpt + 1
                Next

                sRefreshOutString = sOutString
            Else
                Exit While
            End If
        End While
    End Sub


    Private Sub RB_SOAP_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RB_SOAP.CheckedChanged
        L_Info.Visible = False
    End Sub

    Private Sub RB_DataServer_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RB_DataServer.CheckedChanged
        L_Info.Visible = True
    End Sub

    Private Sub DisplayTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisplayTimer.Tick
        L_AutoRefreshInfo.Text = sRefreshOutString
    End Sub

End Class
