Public Class TransducerCalibration
    Private MX_Common As MXCommon_WebReference.MXCommon
    Private MSXE371x As MSXE371x_WebReference.MSXE371x
    Private MXResponse As MXCommon_WebReference.DefaultResponse
    Private Response As MSXE371x_WebReference.DefaultResponse
    Private RetValue As Integer = 0
    Private syserno As Integer = 0
    Private ulLastStatus As UInt64 = 0
    Private dRange As Double = 0
    Private dPosition As Double = 0
    Private TranducerInformations() As TranducerInfo


    Private Function ulGetNbrOfTransducerChannel(ByVal sModuleType As String) As UInt64
        If sModuleType.IndexOf("-", 0) = -1 Then
            Return 0
        End If
        sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1)

        If sModuleType.IndexOf("-", 0) = -1 Then
            Return 0
        End If
        sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1)

        If sModuleType.IndexOf("-", 0) = -1 Then
            Return 0
        End If
        sModuleType = sModuleType.Remove(sModuleType.IndexOf("-", 0))

        Return (Convert.ToUInt64(sModuleType))
    End Function

    Public Class TranducerInfo
        Private ulSelectionIndex As System.UInt64
        Private sName As String
        Private ulCalibrationStatus As System.UInt64
        Private ulCalibratedChannels As System.UInt64
        Private ulType As System.UInt64
        Private ulFrequency As System.UInt64
        Private ulImpedance As System.UInt64
        Private dVeff As Double
        Private dSensibility As Double
        Private dRange As Double

        Public Sub New(ByVal SelectionIndex As ULong, _
                       ByVal Name As String, _
                       ByVal CalibrationStatus As ULong, _
                       ByVal CalibratedChannels As ULong, _
                       ByVal Type As ULong, _
                       ByVal Frequency As ULong, _
                       ByVal Impedance As ULong, _
                       ByVal Veff As Double, _
                       ByVal Sensibility As Double, _
                       ByVal Range As Double)
            ulSelectionIndex = SelectionIndex
            sName = Name.Remove(Name.IndexOf(Chr(0)))
            ulCalibrationStatus = CalibrationStatus
            ulCalibratedChannels = CalibratedChannels
            ulType = Type
            ulFrequency = Frequency
            ulImpedance = Impedance
            dVeff = Veff
            dSensibility = Sensibility
            dRange = Range
        End Sub

        Public Property SelectionIndex() As System.UInt64
            Get
                Return (ulSelectionIndex)
            End Get
            Set(ByVal Value As System.UInt64)
                ulSelectionIndex = Value
            End Set
        End Property
        Public Property CalibrationStatus() As System.UInt64
            Get
                Return (ulCalibrationStatus)
            End Get
            Set(ByVal Value As System.UInt64)
                ulCalibrationStatus = value
            End Set
        End Property
        Public Property CalibratedChannels() As System.UInt64
            Get
                Return (ulCalibratedChannels)
            End Get
            Set(ByVal Value As System.UInt64)
                ulCalibratedChannels = value
            End Set
        End Property
        Public Property Type() As System.UInt64
            Get
                Return (ulType)
            End Get
            Set(ByVal Value As System.UInt64)
                ulType = value
            End Set
        End Property
        Public Property Frequency() As System.UInt64
            Get
                Return (ulFrequency)
            End Get
            Set(ByVal Value As System.UInt64)
                ulFrequency = value
            End Set
        End Property
        Public Property Impedance() As System.UInt64
            Get
                Return (ulImpedance)
            End Get
            Set(ByVal Value As System.UInt64)
                ulImpedance = value
            End Set
        End Property
        Public Property Veff() As Double
            Get
                Return (dVeff)
            End Get
            Set(ByVal Value As Double)
                dVeff = value
            End Set
        End Property
        Public Property Sensibility() As Double
            Get
                Return (dSensibility)
            End Get
            Set(ByVal Value As Double)
                dSensibility = value
            End Set
        End Property
        Public Property Range() As Double
            Get
                Return (dRange)
            End Get
            Set(ByVal Value As Double)
                dRange = value
            End Set
        End Property
        Public Property Name() As String
            Get
                Return (sName)
            End Get
            Set(ByVal Value As String)
                sName = value
            End Set
        End Property

        Public Overrides Function ToString() As String
            Dim sRet As String

            sRet = "Transducer Selection Index : " + ulSelectionIndex.ToString()
            sRet = sRet + Environment.NewLine + "Name                                   : " + sName
            sRet = sRet + Environment.NewLine + "Calibration status                  : " + ulCalibrationStatus.ToString()
            sRet = sRet + Environment.NewLine + "Type Value                          : " + ulType.ToString()
            sRet = sRet + Environment.NewLine + "Frequency                           : " + ulFrequency.ToString() + " Hz"
            sRet = sRet + Environment.NewLine + "Impedance                          : " + ulImpedance.ToString() + " Ohm"
            sRet = sRet + Environment.NewLine + "Nominal Voltage                  : " + dVeff.ToString() + " V"
            sRet = sRet + Environment.NewLine + "Sensibility                            : " + dSensibility.ToString() + " mV/V/mm"
            sRet = sRet + Environment.NewLine + "Range                                 : +/-" + dRange.ToString() + " mm"

            Return (sRet)
        End Function
    End Class


    Public Class ListData
        Private myItem As String
        Private myValue As Long

        Public Sub New(ByVal strItem As String, ByVal lValue As Long)

            Me.myItem = strItem
            Me.myValue = lValue
        End Sub

        Public ReadOnly Property Item() As String
            Get
                Return myItem
            End Get
        End Property

        Public ReadOnly Property Value() As Long
            Get
                Return myValue
            End Get
        End Property
    End Class

    Private Sub TransducerCalibration_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MX_Common = New MXCommon_WebReference.MXCommon()
        MSXE371x = New MSXE371x_WebReference.MSXE371x()
        MX_Common.Timeout = 5000
        MSXE371x.Timeout = 5000
        TB_CalibrationStatus.ReadOnly = True
    End Sub

    Private Sub LB_TransducerList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_TransducerList.SelectedIndexChanged
        L_TransducerInfo.Text = TranducerInformations(LB_TransducerList.SelectedIndex).ToString()
    End Sub

    Private Sub TransducerCalibration_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If Not MSXE371x Is Nothing Then
            MSXE371x = Nothing
        End If
        If Not MX_Common Is Nothing Then
            MX_Common = Nothing
        End If

        System.GC.Collect()
    End Sub

    Private Sub TransducerCalibration_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        B_BreakCalibration_Click(sender, Nothing)
    End Sub

    Private Sub B_Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_Connect.Click
        Dim enc As System.Text.ASCIIEncoding = New System.Text.ASCIIEncoding()
        Dim pcName() As Byte = New Byte(255) {}
        Dim ulNbrOfTransducers As System.UInt64
        Dim ulNbrOfChannels As System.UInt64
        Dim ulSelectionIndex As System.UInt64
        Dim ulCalibrationStatus As System.UInt64
        Dim ulCalibratedChannels As System.UInt64
        Dim ulType As System.UInt64
        Dim ulFrequency As System.UInt64
        Dim ulImpedance As System.UInt64
        Dim dVeff As Double
        Dim dSensibility As Double
        Dim dRange As Double

        If (TB_IPAddress_0.Text.ToString() = "") Or (TB_IPAddress_1.Text.ToString() = "") Or (TB_IPAddress_2.Text.ToString() = "") Or (TB_IPAddress_3.Text.ToString() = "") Then
            MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256) Then
                If (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256) Then
                    If (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256) Then
                        If (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256) Then

                            B_StartCalibration.Enabled = False
                            MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555"
                            MSXE371x.Url = MX_Common.Url

                            Try
                                ' Get the number of transducers type

                                Response = MSXE371x.TransducerGetNbrOfType(ulNbrOfTransducers)
                                If Response.iReturnValue <> 0 Then
                                    MessageBox.Show("TransducerGetNbrOfType Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                    Return
                                End If
                            Catch ex As Exception
                                MessageBox.Show("TransducerGetNbrOfType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                Return
                            End Try

                            TranducerInformations = New TranducerInfo(ulNbrOfTransducers) {}
                            Dim Transducers As ArrayList = New ArrayList()
                            L_NbrOfTransducers.Text = ulNbrOfTransducers.ToString()

                            Dim ulCpt As System.UInt64
                            For ulCpt = 0 To ulNbrOfTransducers - 1 Step ulCpt + 1
                                ' Get the transducer informations
                                MSXE371x.TransducerGetTypeInformation(ulCpt, _
                                                                       ulSelectionIndex, _
                                                                       pcName, _
                                                                       ulCalibrationStatus, _
                                                                       ulCalibratedChannels, _
                                                                       ulType, _
                                                                       ulFrequency, _
                                                                       ulImpedance, _
                                                                       dVeff, _
                                                                       dSensibility, _
                                                                       dRange)

                                ' Save the transducer informations
                                TranducerInformations(ulCpt) = New TranducerInfo(ulSelectionIndex, _
                                                                                 enc.GetString(pcName), _
                                                                                 ulCalibrationStatus, _
                                                                                 ulCalibratedChannels, _
                                                                                 ulType, _
                                                                                 ulFrequency, _
                                                                                 ulImpedance, _
                                                                                 dVeff, _
                                                                                 dSensibility, _
                                                                                 dRange)

                                Transducers.Add(New ListData(enc.GetString(pcName), CType(ulSelectionIndex, Long)))
                            Next

                            LB_TransducerList.DataSource = Transducers
                            LB_TransducerList.DisplayMember = "Item"
                            LB_TransducerList.ValueMember = "Value"

                            ' Get the module type
                            MXResponse = MX_Common.GetModuleType(pcName)
                            ulNbrOfChannels = ulGetNbrOfTransducerChannel(enc.GetString(pcName))

                            ' Channel list box initialisation
                            Dim Channels As ArrayList = New ArrayList()
                            Channels.Add(New ListData("All", 255))

                            Dim i As Long
                            For i = 0 To ulNbrOfChannels - 1
                                Channels.Add(New ListData(i.ToString(), i))
                            Next

                            LB_Channel.DisplayMember = "Item"
                            LB_Channel.ValueMember = "Value"
                            LB_Channel.DataSource = Channels

                            GB_Transducers.Enabled = True
                            B_StartCalibration.Enabled = True

                        Else
                            MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    Else
                        MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Else
                MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub B_StartCalibration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StartCalibration.Click
        Dim ulCalibrationMode As System.UInt64 = 0

        Try

            ulLastStatus = 0
            TB_CalibrationStatus.Text = ""
            L_CalibrationValue.Text = ""

            dRange = TranducerInformations(LB_TransducerList.SelectedIndex).Range
            dPosition = dRange / 2

            ' Get the calibration mmode
            If Convert.ToInt32(LB_Channel.SelectedValue) <> 255 Then
                ulCalibrationMode = 1
            End If

            'Init and start the calibration

            RetValue = MSXE371x.CalibrationStart(Convert.ToUInt32(LB_TransducerList.SelectedValue), _
                                                 dPosition, _
                                                 ulCalibrationMode, _
                                                 Convert.ToUInt32(CB_Invert.Checked), _
                                                 Convert.ToUInt32(LB_Channel.SelectedValue), _
                                                 syserno)

            If RetValue <> 0 Then
                MessageBox.Show("CalibrationStart Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Else
                B_Connect.Enabled = False
                GB_Transducers.Enabled = False
                B_StartCalibration.Enabled = False
                B_NextStep.Enabled = False
                LB_Channel.Enabled = False
                CB_Invert.Enabled = False
                B_BreakCalibration.Enabled = True
                T_Calibration.Enabled = True
            End If
        Catch ex As Exception
            MessageBox.Show("CalibrationStart Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub B_NextStep_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_NextStep.Click
        B_NextStep.Enabled = False
        T_Color.Enabled = False
        B_NextStep.ForeColor = Color.Black

        Try
            'Init and start the calibration

            RetValue = MSXE371x.CalibrationNextStep(syserno)

            If RetValue <> 0 Then
                MessageBox.Show("CalibrationNextStep Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        Catch ex As Exception
            MessageBox.Show("CalibrationNextStep Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub B_BreakCalibration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_BreakCalibration.Click
        If B_BreakCalibration.Enabled = True Then
            Try
                'Init and start the calibration

                RetValue = MSXE371x.CalibrationBreak(syserno)

                If RetValue <> 0 Then
                    MessageBox.Show("CalibrationBreak Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Catch ex As Exception
                MessageBox.Show("CalibrationBreak Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub

    Private Sub T_Calibration_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles T_Calibration.Tick
        Dim ulStatus As UInt64 = 0
        Dim ulDigitalValue As UInt64 = 0
        Dim ulChannel As UInt64 = 0
        Dim dChannelValue As Double = 0
        Dim b_SaveResponse() As System.Byte = New System.Byte(200) {}

        Try
            ' Get calibration current status
            Response = MSXE371x.CalibrationGetCurrentStatus(ulStatus, ulChannel, ulDigitalValue)

            ' Test if error occur

            If Response.iReturnValue <> 0 Then
                MessageBox.Show("CalibrationGetCurrentStatus Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If
        Catch ex As Exception
            MessageBox.Show("CalibrationGetCurrentStatus Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        'Test if start primary calibration 
        If ((ulStatus = 1) Or ((ulStatus = 2))) And (ulLastStatus = 0) Then
            TB_CalibrationStatus.Text = "Primary calibration started" + Environment.NewLine
            If ulStatus = 2 Then
                ulLastStatus = 1
            End If
        End If

        ' Test if primary calibration started 
        If (ulStatus = 1) And (ulLastStatus = 1) Then
            ' Calculate V 
            dChannelValue = (((2.8 * 2.0) / Convert.ToDouble(&HFFFFFF)) * Convert.ToDouble(ulDigitalValue)) - 2.8

            L_CalibrationValue.Text = "Primary calibration : " + dChannelValue.ToString("F") + "V"
        End If

        ' Test if end primary calibration 
        If (ulStatus = 2) And (ulLastStatus <> 2) Then
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Primary calibration conclude" + Environment.NewLine
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Set the transducer connected to channel " + ulChannel.ToString() + " to position 0 mm and click next" + Environment.NewLine
            B_NextStep.Enabled = True
            T_Color.Enabled = True
        End If

        ' Test if wait user set transducer to 0mm 
        If (ulStatus = 2) And (ulLastStatus = 2) Then
            ' Calculate the position into mm 
            dChannelValue = (((dRange * 2.0) / Convert.ToDouble(&HFFFFFF)) * Convert.ToDouble(ulDigitalValue)) - dRange

            L_CalibrationValue.Text = "Transducer position = " + dChannelValue.ToString("F4") + " mm"
        End If

        ' Test if start null position calibration 
        If (ulStatus = 3) And (ulLastStatus <> 3) Then
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Null position calibration started" + Environment.NewLine
        End If

        ' Test if null position calibration 
        If (ulStatus = 3) And (ulLastStatus = 3) Then
            ' Calculate the position into mm 
            dChannelValue = (((dRange * 2.0) / Convert.ToDouble(&HFFFFFF)) * Convert.ToDouble(ulDigitalValue)) - dRange

            L_CalibrationValue.Text = "Transducer position = " + dChannelValue.ToString("F4") + " mm"
        End If

        ' Test if end user position calibration 
        If (ulStatus = 4) And (ulLastStatus <> 4) Then
            If ulLastStatus <> 0 Then
                TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Null position calibration conclude" + Environment.NewLine
            End If
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Set the transducer connected to channel " + ulChannel.ToString() + " to position " + dPosition.ToString("G4") + "mm and click next" + Environment.NewLine
            B_NextStep.Enabled = True
            T_Color.Enabled = True
        End If

        ' Test if wait user set transducer to user position 
        If (ulStatus = 4) And (ulLastStatus = 4) Then
            ' Calculate the position into mm 
            dChannelValue = (((dRange * 2.0) / Convert.ToDouble(&HFFFFFF)) * Convert.ToDouble(ulDigitalValue)) - dRange

            L_CalibrationValue.Text = "Transducer position = " + dChannelValue.ToString("F4") + " mm"
        End If

        ' Test if start user position calibration 
        If (ulStatus = 5) And (ulLastStatus <> 5) Then
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "User position calibration started" + Environment.NewLine
        End If

        ' Test if user position calibration 
        If (ulStatus = 5) And (ulLastStatus = 5) Then
            ' Calculate the position into mm 
            dChannelValue = (((dRange * 2.0) / Convert.ToDouble(&HFFFFFF)) * Convert.ToDouble(ulDigitalValue)) - dRange

            L_CalibrationValue.Text = "Transducer position = " + dChannelValue.ToString("F4") + " mm"
        End If

        ' Test if end user position calibration 
        If (ulStatus = 6) And (ulLastStatus <> 6) Then
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "User position calibration conclude" + Environment.NewLine
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Connect only one transducer and click next" + Environment.NewLine
            B_NextStep.Enabled = True
            T_Color.Enabled = True
        End If


        ' Test if wait that user connect only one transducer 
        If (ulStatus = 7) And (ulLastStatus <> 7) Then
            TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + "Primary open line calibration started"
        End If


        ' Test if primary open line test calibration
        If (ulStatus = 7) And (ulLastStatus = 7) Then
            ' Calculate V 
            dChannelValue = (((2.8 * 2.0) / Convert.ToDouble(&HFFFFFF)) * Convert.ToDouble(ulDigitalValue)) - 2.8

            L_CalibrationValue.Text = "Primary open line calibration : " + dChannelValue.ToString("F") + "V"
        End If

        ' Test if end calibration 
        If (ulStatus = 8) And (ulLastStatus <> 8) Then
            B_StartCalibration.Enabled = True
            B_BreakCalibration.Enabled = False
            B_NextStep.Enabled = False
            LB_Channel.Enabled = True
            CB_Invert.Enabled = True
            GB_Transducers.Enabled = True
            T_Calibration.Enabled = False
            T_Color.Enabled = False
            B_NextStep.ForeColor = Color.Black
            B_Connect.Enabled = True

            ' Error management 
            Select Case ulDigitalValue
                Case 0
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "Calibration conclude" + Environment.NewLine

                    Try
                        ' Save transducer board data-base 
                        Response = MSXE371x.DataBaseSaveTransducers(b_SaveResponse)

                        ' Test if error occur
                        If Response.iReturnValue <> 0 Then
                            MessageBox.Show("DataBaseSaveTransducers Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Return
                        End If
                    Catch ex As Exception
                        MessageBox.Show("DataBaseSaveTransducers Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End Try
                    Exit Sub

                Case 1
                    ' Stop the calibration 
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "!!!User have break the calibration"
                    Exit Sub

                Case 2
                Case 3
                Case 4
                Case 5
                Case 6
                Case 7
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "Can not calibrate the primary feedback"
                    Exit Sub

                Case 8
                Case 9
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "The 0mm position can not by found." + Environment.NewLine + "Restart the calibration and select a new position for the 0mm."
                    Exit Sub

                Case 10
                Case 11
                Case 12
                Case 13
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "The user position can not by found." + Environment.NewLine + "Restart the calibration and select a new position"
                    Exit Sub

                Case 14
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "Primary short circuit occur"
                    Exit Sub

                Case Else
                    ' Format and show the error 
                    TB_CalibrationStatus.Text = TB_CalibrationStatus.Text + Environment.NewLine + "Calibration error -" + ulDigitalValue.ToString()
                    Exit Sub
            End Select
        End If

        If ulLastStatus <> ulStatus Then
            TB_CalibrationStatus.SelectionStart = TB_CalibrationStatus.Text.Length
            TB_CalibrationStatus.ScrollToCaret()
        End If

        ulLastStatus = ulStatus
    End Sub

    Private Sub T_Color_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles T_Color.Tick
        If B_NextStep.ForeColor = B_NextStep.BackColor Then
            B_NextStep.ForeColor = Color.Black
        Else
            B_NextStep.ForeColor = B_NextStep.BackColor
        End If
    End Sub

End Class
