Imports System.Net
Imports System.Net.Sockets

Public Class TransducerDiagnostic

    Private MX_Common As MXCommon_WebReference.MXCommon
    Private MSXE371x As MSXE371x_WebReference.MSXE371x
    Private Response As MSXE371x_WebReference.DefaultResponse
    Private MXResponse As MXCommon_WebReference.DefaultResponse
    Private RetValue As Integer = 0
    Private syserno As Integer = 0
    Private Socket As TcpClient
    Private Stream As NetworkStream
    Private bBuffer() As Byte = New Byte(100) {}
    Private bEventFormat() As Byte = New Byte(1) {}
    Private bEventSize() As Byte = New Byte(255) {}
    Private S_IODRIVER As Byte = 2

    Public Class ListData
        Private myItem As String
        Private myValue As Long

        Public Sub New(ByVal strItem As String, ByVal lValue As Long)

            Me.myItem = strItem
            Me.myValue = lValue
        End Sub

        Public ReadOnly Property Item() As String
            Get
                Return myItem
            End Get
        End Property

        Public ReadOnly Property Value() As Long
            Get
                Return myValue
            End Get
        End Property
    End Class


    Private Sub TransducerDiagnostic_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MX_Common = New MXCommon_WebReference.MXCommon()
        MSXE371x = New MSXE371x_WebReference.MSXE371x()
        MX_Common.Timeout = 5000
        MSXE371x.Timeout = 10000
    End Sub


    Private Sub TransducerDiagnostic_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If Not MSXE371x Is Nothing Then
            MSXE371x = Nothing
        End If
        If Not MX_Common Is Nothing Then
            MX_Common = Nothing
        End If

        System.GC.Collect()
    End Sub

    Private Function ulGetNbrOfTransducerChannel(ByVal sModuleType As String) As UInt64
        If sModuleType.IndexOf("-", 0) = -1 Then
            Return 0
        End If
        sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1)

        If sModuleType.IndexOf("-", 0) = -1 Then
            Return 0
        End If
        sModuleType = sModuleType.Substring(sModuleType.IndexOf("-", 0) + 1)

        If sModuleType.IndexOf("-", 0) = -1 Then
            Return 0
        End If
        sModuleType = sModuleType.Remove(sModuleType.IndexOf("-", 0))

        Return (Convert.ToUInt64(sModuleType))
    End Function

    Private Function s_GetSysErrnoString(ByVal isyserrno As Integer) As String
        Dim pbErrno(255) As Byte
        Dim dResponse As MXCommon_WebReference.DefaultResponse
        Dim enc As System.Text.ASCIIEncoding = New System.Text.ASCIIEncoding()

        dResponse = MX_Common.Strerror(isyserrno, pbErrno)
        If dResponse.iReturnValue = 0 Then
            Return (enc.GetString(pbErrno))
        Else
            Return ("unknown error")
        End If
    End Function

    Private Sub B_Connect_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_Connect.Click
        Dim enc As System.Text.ASCIIEncoding = New System.Text.ASCIIEncoding()
        Dim pcName() As Byte = New Byte(255) {}
        Dim ulNbrOfChannels As System.UInt64

        If (TB_IPAddress_0.Text.ToString() = "") Or (TB_IPAddress_1.Text.ToString() = "") Or (TB_IPAddress_2.Text.ToString() = "") Or (TB_IPAddress_3.Text.ToString() = "") Then
            MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256) Then
                If (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256) Then
                    If (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256) Then
                        If (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256) Then
                            GB_EventMonitoring.Enabled = False
                            GB_SecondaryTest.Enabled = False
                            GB_PrimaryTest.Enabled = False

                            MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555"
                            MSXE371x.Url = MX_Common.Url

                            Try
                                ' Get the module type

                                MXResponse = MX_Common.GetModuleType(pcName)
                                If MXResponse.iReturnValue <> 0 Then
                                    MessageBox.Show("GetModuleType Error : " + MXResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                    Return
                                End If
                            Catch ex As Exception
                                MessageBox.Show("GetModuleType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                Return
                            End Try

                            ulNbrOfChannels = ulGetNbrOfTransducerChannel(enc.GetString(pcName))
                            Dim Channels As ArrayList = New ArrayList()
                            Dim i As Long
                            For i = 0 To ulNbrOfChannels - 1
                                Channels.Add(New ListData(i.ToString(), i))
                            Next

                            LB_Channel.DisplayMember = "Item"
                            LB_Channel.ValueMember = "Value"
                            LB_Channel.DataSource = Channels

                            GB_EventMonitoring.Enabled = True
                            GB_SecondaryTest.Enabled = True
                            GB_PrimaryTest.Enabled = True

                        Else
                            MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    Else
                        MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Else
                MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub B_PrimaryInitialisation_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_PrimaryInitialisation.Click

        Try
            RetValue = MSXE371x.TransducerInitPrimaryConnectionTest(syserno)
            If RetValue = 0 Then
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerInitPrimaryConnectionTest OK " + Environment.NewLine
                B_PrimaryConnectionTest.Enabled = True
            Else
                TB_DiagnosticStatus.Text = "TransducerInitPrimaryConnectionTest Error : " + RetValue.ToString()

                If RetValue = -1 Then
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + " " + s_GetSysErrnoString(syserno)
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("TransducerInitPrimaryConnectionTest Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length
        TB_DiagnosticStatus.ScrollToCaret()
    End Sub

    Private Sub B_PrimaryConnectionTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_PrimaryConnectionTest.Click
        Dim sStatus() As String = New String() {"Any connection open", "All connections OK"}

        Dim ulStatus As System.UInt64

        Try
            Response = MSXE371x.TransducerTestPrimaryConnection(ulStatus)

            If Response.iReturnValue = 0 Then
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryConnection OK Status : " + sStatus(ulStatus) + " (" + ulStatus.ToString() + ")" + Environment.NewLine
            Else
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryConnection Error : " + Response.iReturnValue.ToString() + Environment.NewLine

                If Response.iReturnValue = -1 Then
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("TransducerTestPrimaryConnection Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length
        TB_DiagnosticStatus.ScrollToCaret()
    End Sub

    Private Sub b_PrimaryShortCircuitTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles b_PrimaryShortCircuitTest.Click
        Dim ulStatus As System.UInt64
        Dim sStatus() As String = New String() {"Short circuit", "No short circuit"}


        Try
            Response = MSXE371x.TransducerTestPrimaryShortCircuit(ulStatus)
            If Response.iReturnValue = 0 Then
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryShortCircuit OK Status : " + sStatus(ulStatus) + " (" + ulStatus.ToString() + ")" + Environment.NewLine
            Else
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestPrimaryShortCircuit Error : " + Response.iReturnValue.ToString() + Environment.NewLine
                If Response.iReturnValue = -1 Then
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("TransducerTestPrimaryShortCircuit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length
        TB_DiagnosticStatus.ScrollToCaret()
    End Sub

    Private Sub B_RearmPrimary_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_RearmPrimary.Click
        Dim ulStatus As System.UInt64
        Dim sStatus() As String = New String() {"Short circuit persist", "Rearme OK"}


        Try
            Response = MSXE371x.TransducerRearmPrimary(ulStatus)
            If Response.iReturnValue = 0 Then
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerRearmPrimary OK Status : " + sStatus(ulStatus) + " (" + ulStatus.ToString() + ")" + Environment.NewLine
            Else
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerRearmPrimary Error : " + Response.iReturnValue.ToString() + Environment.NewLine
                If Response.iReturnValue = -1 Then
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("TransducerRearmPrimary Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length
        TB_DiagnosticStatus.ScrollToCaret()
    End Sub

    Private Sub B_SecondaryConnectionTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_SecondaryConnectionTest.Click
        Dim ulStatus As System.UInt64
        Dim sStatus() As String = New String() {"Connection opent", "Connection OK"}


        Try
            Response = MSXE371x.TransducerTestSecondaryConnection(Convert.ToUInt32(LB_Channel.SelectedValue), ulStatus)
            If Response.iReturnValue = 0 Then
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryConnection OK Channel: " + sStatus(ulStatus) + " (" + ulStatus.ToString() + ")" + Environment.NewLine
            Else
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryConnection Error : " + Response.iReturnValue.ToString() + Environment.NewLine
                If Response.iReturnValue = -1 Then
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("TransducerTestSecondaryConnection Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length
        TB_DiagnosticStatus.ScrollToCaret()
    End Sub

    Private Sub b_SecondaryShortCircuitTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles b_SecondaryShortCircuitTest.Click
        Dim ulStatus As System.UInt64
        Dim sStatus() As String = New String() {"Short circuit", "No short circuit"}


        Try
            Response = MSXE371x.TransducerTestSecondaryShortCircuit(Convert.ToUInt32(LB_Channel.SelectedValue), ulStatus)
            If Response.iReturnValue = 0 Then
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryShortCircuit OK Channel: " + sStatus(ulStatus) + " (" + ulStatus.ToString() + ")" + Environment.NewLine
            Else
                TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + "TransducerTestSecondaryShortCircuit Error : " + Response.iReturnValue.ToString() + Environment.NewLine
                If Response.iReturnValue = -1 Then
                    TB_DiagnosticStatus.Text = TB_DiagnosticStatus.Text + s_GetSysErrnoString(Response.syserrno) + Environment.NewLine
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("TransducerTestSecondaryShortCircuit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End Try

        TB_DiagnosticStatus.SelectionStart = TB_DiagnosticStatus.Text.Length
        TB_DiagnosticStatus.ScrollToCaret()
    End Sub

    Private Sub B_StartEventMonitoring_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_StartEventMonitoring.Click
        Try
            Socket = New TcpClient()

            ' Open the socket connection to receive the event
            Socket.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 6363)

            Socket.ReceiveBufferSize = 1048576

            TB_EventMonitor.Text = "Socket connected" + Environment.NewLine

            Stream = Socket.GetStream()

            T_Event.Enabled = True
            B_StopEventMonitoring.Enabled = True
            B_StartEventMonitoring.Enabled = False


        Catch ex As Exception
            MessageBox.Show("Socket connection Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

    End Sub

    Private Sub T_Event_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles T_Event.Tick
        Dim iReceive As Integer = 0

        Try
            ' Test if data available
            If Stream.DataAvailable = True Then
                ' Read the event format
                iReceive = Stream.Read(bEventFormat, 0, 1)
            End If

            If bEventFormat(0) = 0 Then
                ' Test if data available
                If Stream.DataAvailable = True Then
                    ' Read the event size
                    iReceive = Stream.Read(bEventSize, 0, 1)
                End If

                ' Test if data available
                If Stream.DataAvailable = True Then
                    ' Read the event
                    iReceive = Stream.Read(bBuffer, 0, bEventSize(0))
                End If
            Else
                TB_EventMonitor.Text = TB_EventMonitor.Text + "Event format not recognized" + Environment.NewLine
                TB_EventMonitor.SelectionStart = TB_EventMonitor.Text.Length
                TB_EventMonitor.ScrollToCaret()
                T_Event.Enabled = False
                B_StopEventMonitoring_Click(sender, e)
            End If
        Catch ex As Exception
            MessageBox.Show("Socket Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            T_Event.Enabled = False
            B_StopEventMonitoring_Click(sender, e)
        End Try

        If iReceive = bEventSize(0) Then
            ' Test the event type
            If bBuffer(0) = S_IODRIVER Then
                TB_EventMonitor.Text = TB_EventMonitor.Text + "ioDriver event received, Status :" + bBuffer(1).ToString() + Environment.NewLine
                TB_EventMonitor.SelectionStart = TB_EventMonitor.Text.Length
                TB_EventMonitor.ScrollToCaret()
            End If
        End If
    End Sub

    Private Sub B_StopEventMonitoring_Click(ByVal sender As Object, ByVal e As EventArgs) Handles B_StopEventMonitoring.Click
        T_Event.Enabled = False
        If B_StopEventMonitoring.Enabled = True Then

            Try
                ' Close the socket connection
                Socket.Close()
            Catch ex As Exception
                MessageBox.Show("Socket Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try

            B_StartEventMonitoring.Enabled = True
            B_StopEventMonitoring.Enabled = False
        End If
    End Sub

    Private Sub New_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        B_StopEventMonitoring_Click(sender, Nothing)
    End Sub
End Class
